/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

|Uq𗘗p1{rs
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigid.h"
#include "../../setup.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

//|UqҰ
float heightFix = 0.1;//2.0;//Œ_̍(m)
float omega, theta;
float velFoot, posFoot;
float speed;//̃Xs[h

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_TestWalk");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 5.0;
	view.vCnt = CVector(0.0, 0.0, 1.5);
	view.theta = -10.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	viscous = 0.0;
	muK = 1.0;
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;
	countStrobo = 0;
	timeStrobo = 0.0;

	//̈ړx
	speed = 1.0;//m/s
	//Uq^p[^̏l
	omega = 0.0;                //px
	theta = theta0 * DEG_TO_RAD;//XΊp(radɕϊ)
	//
	velFoot = 0.0;
	posFoot = 0.0;

	numRigid0 = 3;
	numRigid = numRigid0 + numStrobo;

	//́i_j̏ݒ
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	//Œ_(cart,)
	rigid[0].kind = BOX;
	rigid[0].color = BLUE;
	rigid[0].mass = MASS;
	rigid[0].vSize = CVector(0.2, 0.3, heightFix);
	rigid[0].vPos = CVector(0.0, posFoot, heightFix / 2.0);
	//
	rigid[1].kind = SPHERE;
	rigid[1].color = CYAN;
	rigid[1].mass = mass0;
	rigid[1].vSize = CVector(1.0, 1.0, 1.0) * size0;
	rigid[1].vPos = CVector(0.0, posFoot + length0 * sin(DEG_TO_RAD * theta0), heightFix + length0 * cos(DEG_TO_RAD*theta0));
	rigid[1].vEuler = CVector(-theta0, 0.0, 0.0);//莩ǧXΊp
	//Uq̖_(rj
	rigid[2].kind = CYLINDER;
	rigid[2].vSize = CVector(0.025, 0.025, length0);
	rigid[2].vPos = CVector(0.0, posFoot + length0 * sin(DEG_TO_RAD * theta0)/2.0, heightFix + length0*cos(DEG_TO_RAD*theta0) / 2.0);
	rigid[2].vEuler = CVector(-theta0, 0.0, 0.0);  
	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		rigid[i].color = GREEN;
		rigid[i].vSize = CVector(0.03, 0.03, 0.03);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}

	rigid[1].select = 1;
	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
  
}

void setTexture()
{
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
 //Ԍv
  QueryPerformanceFrequency( &freq );
  QueryPerformanceCounter( &currentTime);
  pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
  double dt = pTime / 1000000.0;//[sec]
  elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
  fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
  {
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
  }
  QueryPerformanceCounter( &lastTime);

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
  else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

  //ݒ
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe == 1)
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glUseProgram(shaderProg);
  GLint imageLoc = glGetUniformLocation(shaderProg, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");

	for(int i = 0; i < numRigid0; i++) 
	{
		if(rigid[i].select == 1) glUniform1i(selLoc, 1);
		else glUniform1i(selLoc, 0);

		rigid[i].draw(false);
	}
	glUniform1i(selLoc, 0);

	if(flagStrobo)
		for(int i = numRigid0; i < numRigid; i++) rigid[i].draw(false);

	glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	float alpha, thetaDeg, mm, ss, cc, force, accelFoot;
	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		ss = sin(theta);
		cc = cos(theta);
		force = k1 * ss;//ɗ^
		mm = MASS + mass0 - mass0 * cc * cc;
		//IC[@
		//
		alpha = ((MASS + mass0) * gravity * ss - force * cc - mass0 * length0 * ss * cc * omega) / (length0 * mm) - viscous * omega / mass0 ;
		omega += alpha * timeStep;
		theta += omega * timeStep;//rad
		if(theta > M_PI / 2.0) theta = M_PI / 2.0;
		if(theta < - M_PI / 2.0) theta = M_PI / 2.0;
		thetaDeg = theta * RAD_TO_DEG;
		//
		float mu = 0;
		if(omega > 0.0) mu = muK;//肪OɈړԖC傫Î~
		else mu = 0.0;
		if(velFoot > 0.0)
			accelFoot = (force + mass0 * length0  * ss * omega * omega - mass0 * gravity * ss * cc) / mm - mu * gravity;
		else 
			accelFoot = (force + mass0 * length0  * ss * omega * omega - mass0 * gravity * ss * cc) / mm + mu * gravity;
		velFoot += accelFoot * timeStep;
		posFoot += velFoot * timeStep;
		rigid[0].vPos.y = posFoot;
		//(yzʂŉ^j
		rigid[1].vPos.y = posFoot + length0 * ss;
		rigid[1].vPos.z = heightFix + length0 * cc;
		rigid[1].vEuler = CVector(-thetaDeg, 0.0, 0.0);//莩g̉]p
		//Uq_irj
		rigid[2].vPos.y = (posFoot + rigid[1].vPos.y) / 2.0;
		rigid[2].vPos.z = heightFix + length0 * cos(theta) / 2.0;
		rigid[2].vEuler = rigid[1].vEuler;

		if(flagOneStep) flagFreeze = true;

		elapseTime2 += timeStep;

		//Strobo
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				rigid[numRigid0 + countStrobo].vPos = rigid[1].vPos;
			}

			timeStrobo += timeStep;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = 0;
		}
	}

	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5); //[hԂ̍W
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/(double)fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	if(flagTrack)
	{
		view.vCnt.y = posFoot;
		setCamera();
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}


