/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ʏ̃olU4i_4ol3j
UȂC4RxUD
IC[@
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigid.h"
#include "../../setup.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

double omega0 = sqrt(constK / mass1);//Upg

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_Spring4");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 5.0;
	view.vCnt = CVector(0.0, 0.0, 0.0);
	view.theta = 15.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	viscous = 0.0;
	muK = 0.0;
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;

	numSpring = 3;
	int i;
	for(i = 0; i < numSpring; i++)
	{
		spring[i] = CSpring();
		spring[i].num3 = 20;//
		spring[i].kind = S_SPRING;
		spring[i].length0 = length0;//R
		spring[i].vPos = CVector(0.0, 0.0, 0.1);
		spring[i].vEuler = CVector(-90.0, 0.0, 0.0);
	}
	spring[0].length = length0 - disp00 + disp01;
	spring[1].length = length0 - disp01 + disp02;
	spring[2].length = length0 - disp02 + disp03;
	spring[0].constK = 10.0;
	spring[1].constK = constK;
	spring[2].constK = 10.0;
	spring[0].vPos = CVector(0.0, disp00 - 3.0 * length0/2.0 + spring[0].length/2.0, 0.1);
	spring[1].vPos = CVector(0.0, disp00 - 3.0 * length0/2.0 + spring[0].length + spring[1].length/2.0, 0.1);
	spring[2].vPos = CVector(0.0, disp00 - 3.0 * length0/2.0 + spring[0].length + spring[1].length + spring[2].length/2.0, 0.1);

	//́i_j̏ݒ
	numRigid = 4;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	//0([j
	rigid[0].kind = BOX;
	rigid[0].color = WHITE;
	rigid[0].mass = 1000.0;//C
	rigid[0].vSize = CVector(0.2, 0.2, 0.2);
	rigid[0].vPos = CVector(0.0, disp00 - length0 * 3.0 / 2.0 , rigid[0].vSize.z / 2.0);
	//1(ԍj
	rigid[1].kind = BOX; 
	rigid[1].color = CYAN;
	rigid[1].mass = mass1;
	rigid[1].vSize = CVector(0.2, 0.2, 0.2);
	rigid[1].vPos = CVector(0.0, disp01 - length0 / 2.0, rigid[1].vSize.z / 2.0);
	//2(ԉEj
	rigid[2].kind = BOX; 
	rigid[2].color = GREEN;
	rigid[2].mass = mass2;
	rigid[2].vSize = CVector(0.2, 0.2, 0.2);
	rigid[2].vPos = CVector(0.0, length0 / 2.0 + disp02, rigid[2].vSize.z / 2.0);
	//3(E[j
	rigid[3].kind = BOX;
	rigid[3].color = WHITE;
	rigid[3].mass = 1000.0;//C
	rigid[3].vSize = CVector(0.2, 0.2, 0.2);
	rigid[3].vPos = CVector(0.0, length0 * 3.0 / 2.0 + disp03, rigid[3].vSize.z / 2.0);

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	glUniform1i(selLoc, 0);

	for(int i = 0; i < numRigid; i++) rigid[i].draw(false);
	for(int i = 0; i < numSpring; i++) spring[i].draw(false);


	spring[0].draw(false);

	glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		double disp0, disp1, disp2, disp3, dir;
		double tt = timeStep / 1000.0;
		for(int j = 0; j < 1000; j++)
		{
			//ol̕ψʗ
			disp0 = rigid[0].vPos.y + 3.0 * length0 /2.0; 
			disp1 = rigid[1].vPos.y + length0 /2.0;
			disp2 = rigid[2].vPos.y - length0 /2.0;
			disp3 = rigid[3].vPos.y - 3.0 * length0 /2.0;

			//Euler
			for(int i = 0; i <= 3; i++)		
			{
				if(rigid[i].vVelocity.y > 0.0) dir = 1.0;
				else dir = -1.0;

				if(i == 0)
					rigid[0].vAccel.y = (spring[0].constK * (disp1 - disp0) - viscous * rigid[0].vVelocity.y) / mass0 - muK * gravity * dir;
				else if(i == 1)
					rigid[1].vAccel.y = (spring[0].constK * disp0 - (spring[0].constK+spring[1].constK) * disp1 + spring[1].constK * disp2 - viscous * rigid[1].vVelocity.y) / mass1 - muK * gravity * dir;
				else if(i == 2)
					rigid[2].vAccel.y = (spring[1].constK * disp1 - (spring[1].constK+spring[2].constK) * disp2 + spring[2].constK * disp3 - viscous * rigid[2].vVelocity.y) / mass2 - muK * gravity * dir;
				else
					rigid[3].vAccel.y = (spring[2].constK * ( disp2 - disp3) - viscous * rigid[3].vVelocity.y) / mass3 - muK * gravity * dir;
				
				rigid[i].vVelocity.y += rigid[i].vAccel.y * tt;
				rigid[i].vPos.y += rigid[i].vVelocity.y * tt;
			}
			for(int i = 0; i < numSpring; i++)
			{
				spring[i].vPos.y = (rigid[i+1].vPos.y + rigid[i].vPos.y) / 2.0;
				spring[i].length = rigid[i+1].vPos.y - rigid[i].vPos.y;
			}
		}

		if(flagOneStep) flagFreeze = true;
		elapseTime2 += dt;
	}


	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();       //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5);   //[hԂ̍W
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}

