/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2ol_f2
pole4{
͂̎_ׂČŒ(ftHg)
IC[@
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
//#define FILENAME_IN "../../bmp/check1.bmp"
#define FILENAME_IN "../../bmp/tiger1-2.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigidSM.h"
#include "../../spring_mass2.h"
#include "../../setupSM2.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_SpringMass2_2");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");
	GLUI_Master.set_glutIdleFunc( idle );

	setupGLUI();//myGLUI.hɎ

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 5.0;
	view.vCnt = CVector(0.0, 0.0, 1.0);
	view.theta = 10.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	muK = 0.2;
	restitut = 0.0;
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	printf("}EX͎_Ɏgp \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;

	sm2.damping = damping;
	sm2.drag = drag;
	sm2.mass = mass0;//KgPʁi_Pj
	sm2.structK = structK0;//olPiŜ1/numSpring)
	sm2.hingeK = hingeK0;
	sm2.shearK = structK0;
	sm2.numRow = numRow0;
	sm2.numCol = numRow0;
	sm2.lengthX0 = length0;
	sm2.lengthY0 = length0;
	sm2.totalLenX = totalLen0;
	sm2.totalLenY = totalLen0;

	sm2.height = 1.0;
	sm2.pointRadius = radius0;
	sm2.vPos = CVector(-totalLen0/2.0, -totalLen0/2.0, sm2.height);
	sm2.initialize();

	for(int j = 0; j <= sm2.numCol; j++)
		for(int i = 0; i <= sm2.numRow; i++) sm2.point[i][j].flagFixed = false;

	//|[ɌŒ
	sm2.point[0][0].flagFixed = true;
	sm2.point[0][sm2.numCol].flagFixed = true;
	sm2.point[sm2.numRow][0].flagFixed = true;
	sm2.point[sm2.numRow][sm2.numCol].flagFixed = true;

	numPole = 4;
	//|[0(j
	sm2.pole[0].vSize = CVector(0.05, 0.05, sm2.height);
	sm2.pole[0].vPos = CVector(-totalLen0 / 2.0, -totalLen0 / 2.0, sm2.height / 2.0);
	sm2.pole[0].kind = CYLINDER;
	sm2.pole[0].color = DARK_YELLOW;
	//|[1(Ej
	sm2.pole[1].vSize = CVector(0.05, 0.05, sm2.height);
	sm2.pole[1].vPos = CVector(-totalLen0 / 2.0, totalLen0 / 2.0, sm2.height / 2.0);
	sm2.pole[1].kind = CYLINDER;
	sm2.pole[1].color = DARK_YELLOW;
	//|[2(Oj
	sm2.pole[2].vSize = CVector(0.05, 0.05, sm2.height);
	sm2.pole[2].vPos = CVector(totalLen0 / 2.0, -totalLen0 / 2.0, sm2.height / 2.0);
	sm2.pole[2].kind = CYLINDER;
	sm2.pole[2].color = DARK_YELLOW;
	//|[3(Ej
	sm2.pole[3].vSize = CVector(0.05, 0.05, sm2.height);
	sm2.pole[3].vPos = CVector(totalLen0 / 2.0, totalLen0 / 2.0, sm2.height / 2.0);
	sm2.pole[3].kind = CYLINDER;
	sm2.pole[3].color = DARK_YELLOW;
	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	sm2.draw(false, selLoc);
	glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 10.0 * timeStep0 || timeStep < timeStep0 / 10.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		double tt = timeStep / 10.0;
		for(int i = 0; i < 10; i++)
		{
			sm2.calcSpringMass(sm2.pole, tt);
		}

		if(flagOneStep) flagFreeze = true;
		elapseTime2 += timeStep;
	}

	if(flagFloor) glCallList(floor0);//En
	
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) drawWorldCoordinates(0.5);//[hԂ̍W
	
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	if(flagTrack)
	{
		view.vCnt.x = sm2.vPos.x;
		view.vCnt.y = sm2.vPos.y;
		setCamera();
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}

