//collision.h
//3oX_fƍ̋̏Փ

void collisionWithRigid(int i, float dt);
//float checkCollision(int i, CRigid rigid, CVector &vNormal);

void collision(float dt)
{
	int i;

	float d;// = vDist(sm3.vPos, sm3.rigid2.vPos);
	//if(d > (sm3.vSize.z + sm3.rigid2.boundingR) / 2.0) return;

	for(i = 0; i < sm3.numPoint; i++)
	{   
		d = vDist(sm3.point[i].vPos,  sm3.rigid2.vPos);
		if( d > sm3.pointRadius + sm3.rigid2.vSize.x / 2.0) continue;
		collisionWithRigid(i, dt);
	}

}
//--------------------------------------------------------------------------
void collisionWithRigid(int i, float dt)
{
	float rikiseki;
	float vn1, vn2;//@̑傫
	float muc, B, m1, m2;
	CVector vVelocityP1, vVelocityP2;//x
	CVector vNormal;//ڍ(_)猩Փ˖ʂ̖@
	CVector vTangential;//ڐ
	CVector vDir, vA1, vA2, vRg1, vRg2;

	sm3.point[i].vForce = CVector();
	sm3.point[i].vTorque = CVector();
	sm3.rigid2.vForce = CVector();
	sm3.rigid2.vTorque = CVector();

	vNormal = sm3.point[i].vPos >> sm3.rigid2.vPos;
	//dSՓ˓_܂ł̃xNg
	sm3.point[i].vGravityToPoint = (sm3.pointRadius) * vNormal;
	sm3.rigid2.vGravityToPoint = (sm3.rigid2.vSize.x/2.0) * vNormal;
	sm3.rigid2.vGravityToPoint.reverse();
	float depth = (sm3.pointRadius + sm3.rigid2.vSize.x / 2.0) - vDist(sm3.point[i].vPos, sm3.rigid2.vPos);

	//float depth = checkCollision(i, sm3.rigid2, vNormal);
//printf("depth=%f \n", depth);
	if(depth < 0.0) return;
	vRg1 = sm3.point[i].vGravityToPoint;
	vRg2 = sm3.rigid2.vGravityToPoint;
	m1 = sm3.point[i].mass;
	m2 = sm3.rigid2.mass;

	vVelocityP1 = sm3.point[i].vVelocity + vCross(sm3.point[i].vOmega, vRg1);
	vn1 = vDot(vVelocityP1, vNormal);
	vVelocityP2 =sm3.rigid2.vVelocity + vCross(sm3.rigid2.vOmega, vRg2);
	vn2 = vDot(vVelocityP2, vNormal);

	//Փˉ
	vTangential = vCross( vNormal, vCross((vVelocityP1 - vVelocityP2), vNormal));
	vTangential.norm();
	//͐
	rikiseki = - (restitut + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2
		  + vDot(vNormal , vCross((sm3.point[i].mInertiaInverse * vCross(vRg1, vNormal)), vRg1))
		  + vDot(vNormal , vCross((sm3.rigid2.mInertiaInverse * vCross(vRg2, vNormal)), vRg2)));
	//͂̑a
	sm3.point[i].vForce += (vNormal) * rikiseki / dt;
	sm3.rigid2.vForce -= (vNormal) * rikiseki / dt;
	//͂̃[gigNj̑a
	sm3.point[i].vTorque += vCross(vRg1, vNormal) * rikiseki / dt;
	sm3.rigid2.vTorque -= vCross(vRg2, vNormal) * rikiseki / dt;

	//Cl
	vA1 = vCross(((sm3.point[i].mInertiaInverse * vCross(vRg1, vTangential))) , vRg1);
	vA2 = vCross(((sm3.rigid2.mInertiaInverse * vCross(vRg2, vTangential))) , vRg2);
	B = - vDot(vTangential, (vVelocityP1-vVelocityP2)) / (1.0f/m1+1.0f/m2+ vDot(vTangential,(vA1+vA2)));
	muc = fabs(B / rikiseki);
	if(muK >= muc)
	{
		sm3.point[i].vForce +=  vTangential* B / dt;
		sm3.point[i].vTorque += vCross(vRg1, vTangential) * B / dt;
		sm3.rigid2.vForce -=  vTangential* B / dt;
		sm3.rigid2.vTorque -= vCross(vRg2, vTangential) * B / dt;
	}
	else
	{
		sm3.point[i].vForce +=  muK * (rikiseki / dt) * vTangential;
		sm3.point[i].vTorque += vCross(vRg1, vTangential) * muK * rikiseki / dt;
		sm3.rigid2.vForce -=  muK * (rikiseki / dt) * vTangential;
		sm3.rigid2.vTorque -= vCross(vRg2, vTangential) * muK * rikiseki / dt;
	}
	//Փ˔莞ɂ߂荞񂾕
	sm3.point[i].vPos -= (depth/2.0) * vNormal;				
	sm3.rigid2.vPos += (depth/2.0) * vNormal;


	//ʒu]px̍XV
	// iԖڂ̍
	sm3.point[i].vAccel = sm3.point[i].vForce / m1;    //x
	sm3.point[i].vVelocity += sm3.point[i].vAccel * dt;//x
	sm3.point[i].vAlpha = sm3.point[i].mInertiaInverse * sm3.point[i].vTorque;//px̍XV
	sm3.point[i].vOmega += sm3.point[i].vAlpha * dt;          //px

	// jԂ̍
	sm3.rigid2.vAccel =sm3.rigid2.vForce / m2;
	sm3.rigid2.vVelocity +=sm3.rigid2.vAccel * dt;
	sm3.rigid2.vAlpha =sm3.rigid2.mInertiaInverse *sm3.rigid2.vTorque;
	sm3.rigid2.vOmega +=sm3.rigid2.vAlpha * dt;

}
