/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ol_f̉z蕨

GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../rigidVSM.h"
#include "spring_mass_vehicle.h"
#include "../../setupVSM.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_Vehicle");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 7.0;
	view.vCnt = CVector(0.0, 0.0, 1.5);
	view.theta = 10.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	viscous = 0.0;
	muK = 1.0;
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;
	countStrobo = 0;
	timeStrobo = 0.0;

	mode = 0;

	sm = CSpringMass();
	sm.damping = damping0;
	sm.drag = drag0;
	numDiv = numDiv0;//ԗ։~̕
	sm.mass = mass0;//KgPʁi_Pj
	sm.length0 = length0;//spoke̒
	sm.radius = radius0; //_̔a
	sm.constK = constK0; //olPiŜ1/numSpring)
	sm.drctnK = drctnK0; //ol̃ol萔
	sm.vPos = CVector(0.0, 0.0, radius0 + length0);  //ԗւ̒S̍
	sm.direction = sm.direction0 = dir0 * DEG_TO_RAD;//isiyj
	sm.ang = sm.ang0 = sm.direction;
	sm.speed = speed0;
	sm.create();
	numRigid = numPoint + numStrobo;

	//̂̏ݒ
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		rigid[i].color = GREEN;
		rigid[i].vSize = CVector(0.03, 0.03, 0.03);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
 	elapseTime3 = 0.0;//0.5secԈȓoߎ
 
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	elapseTime3 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	if(elapseTime3 >= 0.5)
	{
		elapseTime3 = 0.0;
		if(flagChange == true) flagChange = false;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");

	for(int i = 0; i < numRigid0; i++) 
	{
		glUniform1i(selLoc, 0);

		sm.draw(false);
	}
	glUniform1i(selLoc, 0);

	if(flagStrobo)
		for(int i = numRigid0; i < numRigid; i++) rigid[i].draw(false);

	glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart==true && flagFreeze == false && flagFreeze0 == false && flagChange == false) 
	{
		if(type == 0) sm.action0(timeStep, elapseTime2);
		else if(type == 1) sm.action1(timeStep, elapseTime2);
		else if(type == 2) sm.action2(timeStep, elapseTime2);

		if(flagOneStep) flagFreeze = true;

		elapseTime2 += timeStep;

		//Strobo
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				rigid[numRigid0 + countStrobo].vPos = sm.point[rootNo].vPos;
			}

			timeStrobo += timeStep;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = 0;
		}
	}

	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5); //[hԂ̍W
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/(double)fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	if(flagTrack)
	{
		view.vCnt.y = sm.point[0].vPos.y;
		setCamera();
	}
	if(flagTrack)
	{
		view.vCnt.x = sm.vPos.x;
		view.vCnt.y = sm.vPos.y;
		setCamera();
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}


