//spring_mass1.h
//1ol_f
//CSЂȂǂ\
#include "../../spring.h"

//#define MAX_SM1 5

//int numSM1 = 1;
int flagCollision = 1;//ՓˏL/
int numPole = 0;
int numPoint = 11;
int rootNo = 5;
int type = 0;
float freqLeg = 0.5;//r𓮂U

enum Boundary { B_FIXED,B_FREE};
Boundary boundary = B_FIXED;

class CSpringMass
{
public:
    CVector vPos;
	float speed;//isx
    //CVector vEuler;
	float mass;//_P̎
    float constK;
	float drctnK;
	float damping;
	float drag;
    float length0;  //sprinĝP莩R
	float totalLen;
	float legLen;
	float frequency;//M̎g
	float amp;      //M̐U

    float radius ;//1ê̔a
	float direction, direction0;//isix̌oxCdegj

    CVector vForce0;//O͂̏l
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];
	CRigid pole[2];

    //o֐
    CSpringMass();
    void draw(bool flagShadow);
    void create();
    void calcSpringMass(double dt);
	void action(double dt, double time);
private:
};
CSpringMass sm;
//---------------------------------------------------------------
CSpringMass::CSpringMass()
{
    vPos = CVector();
    length0 = 0.1;
//	repulseForce = 0.0;
	direction = 90.0 * DEG_TO_RAD;//y
	constK = 1000.0;
	drctnK = 100.0;
	totalLen = 1.0;
	legLen = 0.3;
	mass = 1.0;
	drag = 0.0;
	damping = 0.0;
    radius = 0.03;
	vForce0 = CVector();
}
//-----------------------------------------------------------------
void CSpringMass::draw(bool flagShadow)
{
    int i;
    int r1, r2;
    CVector vEuler0, vEuler1;

    //΂ˎ_\
    //_
    for(i = 0; i < numPoint; i++) {
        point[i].color = CYAN;
        if(point[i].flagFixed == true){
            point[i].color= RED;
        }
        point[i].draw(flagShadow);
    }
    for(i = 0; i < numSpring; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }
    for(i = 0; i < numPole; i++)
    {
		pole[i].draw(flagShadow);
	}
}
//-----------------------------------------------------------------
void CSpringMass::create()
{
    int i;
	float len = 2.0 * totalLen / (float)numSpring;//̊Ԋu

	rootNo = numSpring / 4;//قڒS
	numPoint = numSpring + 1;

	if(type == 0)
	{
		//_̈ʒu
		for(i = 0; i <= numSpring/2; i++)
		{//
			point[i].vPos = CVector(0.0, -(float)i * len, radius + legLen) + vPos;
		}
		for(i = numSpring/2+1; i <= numSpring; i++)
		{//
			point[i].vPos = CVector(0.0, -(float)(i-numSpring/2) * len, radius) + vPos;
		}
		//ol̎RƗ[̎_ԍ,
		for(i = 0; i <= numSpring/2-1; i++)
		{//
			spring[i].length0 = len;
			spring[i].row1 = i+1; spring[i].row2 = i;
			spring[i].vDir0 = CVector(0.0, 1.0, 0.0);
		}
		for(i = numSpring/2; i < numSpring; i++)
		{//r
			spring[i].length0 = legLen;
			spring[i].row1 = i + 1; spring[i].row2 = i - numSpring/2 + 1;//row1
			spring[i].vDir0 = CVector(0.0, 0.0, 1.0);
		}
		//_̃TCY,
		for(int i = 0; i < numPoint; i++){
			point[i].kind = SPHERE;
			point[i].vSize = CVector(2.0, 2.0, 2.0) * radius;
			point[i].mass = mass;
			point[i].vSize = CVector(2.0*radius, 2.0*radius, 2.0*radius);
			point[i].direction = direction;
			point[i].flagFixed = false;
		}
	}
	else if(type == 1)
	{
		double lambda = 2.0 * totalLen;
		//_̈ʒu
		for(i = 0; i <= numSpring/2; i++)
		{//
			point[i].vPos = CVector(0.0, -(float)i * len, radius + legLen*(1.0 + 0.5 * sin(2.0 * M_PI * (double)i*len / double(lambda)))) + vPos;
		}
		point[0].vPos.z += 0.8 * len;//

		for(i = numSpring/2+1; i <= numSpring; i++)
		{//
			point[i].vPos = CVector(0.0, -(float)(i-numSpring/2) * len, radius) + vPos;
		}
		//ol̎RƗ[̎_ԍ,
		for(i = 0; i <= numSpring/2-1; i++)
		{//
			spring[i].row1 = i+1; spring[i].row2 = i;
			spring[i].length0 = vDist(point[spring[i].row1].vPos, point[spring[i].row2].vPos);
			spring[i].vDir0 = point[spring[i].row1].vPos >> point[spring[i].row2].vPos;//CVector(0.0, 1.0, 0.0);
		}
		for(i = numSpring/2; i < numSpring; i++)
		{//r
			int k = i-numSpring/2;
			spring[i].length0 = legLen*(1.0 + 0.8 * sin(2.0 * M_PI * (double)k*len / double(lambda)));
			spring[i].row1 = i + 1; spring[i].row2 = i - numSpring/2 + 1;//row1
			spring[i].vDir0 = CVector(0.0, 0.0, 1.0);
		}
		//_̃TCY,
		for(int i = 0; i < numPoint; i++){
			point[i].kind = SPHERE;
			point[i].vSize = CVector(2.0, 2.0, 2.0) * radius;
			point[i].mass = mass;
			point[i].vSize = CVector(2.0*radius, 2.0*radius, 2.0*radius);
			point[i].direction = direction;
			point[i].flagFixed = false;
		}
	}

	//ol
    for(int i = 0; i < numSpring; i++){
		spring[i].radius = radius;
        spring[i].kind = S_CYLINDER;
	}

	//islyłȂƂ_̈ʒu/ol̕xNgς
	double alpha = direction - M_PI/2.0;
	if(alpha != 0.0)
	{
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ(alpha * RAD_TO_DEG);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
	}

}

//-----------------------------------------------------------------------------
//1̃ol}Xf(drctn springlCRԂŉ^)
void CSpringMass::calcSpringMass(double dt)
{                                           
    int i, r1, r2;
    CVector vDir1, vDir2;
    CVector vFF, vRelativeVelocity;
    float dampingF;
    float angle;
    CVector vNormal;

	//͂̑a
    //ݒliÓj
    for(i = 0; i  < numPoint; i++)
        point[i].vForce = vForce0 + CVector(0.0, 0.0, -gravity * mass);

	//olɂ
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (spring[i].length - spring[i].length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

	//oll
	for(i = 0; i < numSpring; i++)
	{
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;
        vNormal = vCross(spring[i].vDir0, vDir1);
		vDir2 = vCross(vNormal, vDir1);
		angle = getAngle(spring[i].vDir0, vDir1);
        vFF = drctnK * angle * vDir2 / spring[i].length;
        point[r2].vForce -= vFF ;
        point[r1].vForce += vFF;//vDir2Ɠ
	}

    //SRƏʏ,lvZ
    for(i = 0; i < numPoint; i++)
    {
		if(point[i].flagFixed == true) continue; //Œ
		
        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

		//ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
		point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
        point[i].vPos += point[i].vVelocity * dt;
    }
	vPos = point[0].vPos;

}
//------------------------------------------------------------------------
void CSpringMass::action(double timeStep, double time)
{
	int i, k;
	double a;
	static double t0 = 0.0;
	static bool flagChange = false;

	for(i = numSpring/2 + 1; i < numPoint; i++) point[i].vPos.z = radius;

	for(i = numSpring/2+1; i <= numSpring; i++)
	{ 
		k = i - numSpring/2 - 1;//̂̎_ԍ
		a = sin(2.0 * M_PI * (freqLeg * time  - (double)k / (double)(numSpring/2))) + 1.0;
		if(a >= 0.0)
		{
			point[i].flagFixed = false;
			point[i].vVelocity.x = speed * cos(direction) * a ; 
			point[i].vVelocity.y = speed * sin(direction) * a ; 
		}
		else{
			point[i].flagFixed = true;
		}
	}

	//isωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;
	if(alpha != 0.0)
	{
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ(alpha * RAD_TO_DEG);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
		direction0 = direction;
	}

	calcSpringMass(timeStep);
}
