
//1ol_f
//CSЂȂǂ\
#include "../../spring.h"

int flagCollision = 1;//ՓˏL/
int numPole = 0;
int numPoint = 11;
//int numHinge = 9;
int actionType = 0;//~~Y

enum Boundary { B_FIXED,B_FREE};
Boundary boundary = B_FIXED;

class CSpringMass
{
public:
    CVector vPos;
	float speed;//isx
	float mass; //_P̎
    float constK;
	float hingeK;
	float damping;
	float drag;
    float length0;  //sprinĝP莩R
	float totalLen;
	float frequency;//wr^g
	float amp;      //wr^̐U
	float delta;    //wr^̒xʑ

    float radius ;//1ê̔a
	float height0;//Ԃ̍
	float repulseForce;

    CVector vForce0;//O͂̏l
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];
	CRigid pole[2];

    //o֐
    CSpringMass();
    void draw(bool flagShadow);
    void create();
    void calcSpringMass(double dt);
	void action(double dt, double time);
private:
};
CSpringMass sm;
//---------------------------------------------------------------
CSpringMass::CSpringMass()
{
    vPos = CVector();
    length0 = 0.1;
	repulseForce = 0.0;
	constK = 1000.0;
	hingeK = 100.0;
	totalLen = 1.0;
	mass = 1.0;
	drag = 0.0;
	damping = 0.0;
    radius = 0.03;
	vForce0 = CVector();
}
//-----------------------------------------------------------------
void CSpringMass::draw(bool flagShadow)
{
    int i;
    int r1, r2;
    CVector vEuler0, vEuler1;

    //΂ˎ_\
    //_
    for(i = 0; i < numPoint; i++) {
        point[i].color = CYAN;
        if(point[i].flagFixed == true){
            point[i].color= RED;
        }
        point[i].draw(flagShadow);
    }
    for(i = 0; i < numSpring; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }
    for(i = 0; i < numPole; i++)
    {
		pole[i].draw(flagShadow);
	}
}
//-----------------------------------------------------------------
void CSpringMass::create()
{
    int i;
	float length1 = totalLen / (float)numSpring;
    //_̃TCYCʒu
    for(i = 0; i <numPoint; i++){
        point[i].kind = SPHERE;
        point[i].vSize = CVector(2.0*radius, 2.0*radius, 2.0*radius);
        point[i].vPos.x = point[i].vPos0.x = 0.0;
        point[i].vPos.y = point[i].vPos0.y = -(float)i * length1;
        point[i].vPos.z = point[i].vPos0.z = height0;
        point[i].vPos += vPos;//Ŝ̕sړ
		point[i].vPos0 = point[i].vPos;
		point[i].vVelocity = CVector();
    }

    //olx,yW(_ɋ߂_Œ`jƉ]p
    //olɐڑ鎿_ԍ
    for(i = 0; i < numSpring; i++)
    {
        spring[i].kind = S_CYLINDER;
        spring[i].radius = radius;
        spring[i].row1 = i;
        spring[i].row2 = i+1;
    }
	//islyłȂƂ_̈ʒuς
	int rootNo = numSpring / 2;
	double alpha = point[0].direction - M_PI/2.0;
	if(alpha != 0.0)
	{
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
	}
}

//-----------------------------------------------------------------------------
//1̃ol}Xf(hinge springlCRԂŉ^)
void CSpringMass::calcSpringMass(double dt)
{                                           
    int i, r1, r2;
    CVector vDir1, vDir2, vFF;
    CVector vRelativeVelocity;
    float dampingF;
    float len, len1, len2, angle;
    double angle0 = M_PI;
    CVector vNormal;

	//͂̑a
    //ݒliÓj
    for(i = 0; i  < numPoint; i++)
        point[i].vForce = vForce0 + CVector(0.0, 0.0, -gravity * mass);

	//olɂ
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        len = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (len - length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

    //qރoll
    for(i = 1; i < numSpring; i++)
    {
        len1 = vDist(point[i].vPos, point[i-1].vPos);
        len2 = vDist(point[i].vPos, point[i+1].vPos);
        //hinge̒Sאڎ_֌xNg
        vDir1 = point[i].vPos >> point[i-1].vPos;
        vDir2 = point[i].vPos >> point[i+1].vPos;
        //Q̃xNĝȂpx
        angle = getAngle(vDir1, vDir2); //radP
        if(angle == angle0) continue;
        //@
        vNormal = vCross(vDir1, vDir2);
        vDir1 = vCross(vNormal, vDir1); //_1ɍp͂̕
        vFF = hingeK * (angle - angle0) * vDir1 / len1;
        point[i-1].vForce += vFF ;//vDir1Ɠ
        point[i].vForce -= vFF;
        vDir2 = vCross(vNormal, vDir2);//_2ɍp͂̕
        vFF = hingeK * (angle - angle0) * vDir2 / len2;
        point[i+1].vForce -= vFF ;//vDir2̔Ε
        point[i].vForce += vFF;
    }

	if(flagCollision == 1)
	{
		//_m̏Փ˖h~̂ߐ˗͂^
		int m1, m2;
		for(m1 = 0; m1 <numPoint-1; m1++){
			for(m2 = m1+2; m2 <numPoint; m2++){
				vDir1 = point[m1].vPos >> point[m2].vPos;//#1#2ւ̒PʃxNg
				len = vDist(point[m1].vPos, point[m2].vPos);
				if(len < 2.0 * length0) {
					vFF = ( repulseForce / (0.0001+len*len) ) * vDir1 ;
					point[m1].vForce -= vFF ;//vDirƔΕ
					point[m2].vForce += vFF ;//
					if(actionType == 1)
					{
						if(point[m1].flagFixed) continue;
						if(point[m2].flagFixed) continue;
						point[m1].vForce.z += repulseForce ;
						point[m2].vForce.z += repulseForce;
					}
				}
			}
		}
	}

    //SRƏʏ
    for(i = 0; i < numPoint; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

		//ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
		point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;
        //ʒu
        point[i].vPos += point[i].vVelocity * dt;

    }
	vPos = point[0].vPos;

}
//------------------------------------------------------------------------
void CSpringMass::action(double timeStep, double time)
{
	double ang;
	
	float period = totalLen / speed ;

	if(actionType == 0)//i^
	{
		float d = vDist(point[0].vPos, point[numPoint-1].vPos);

		if(d < totalLen) d = totalLen;

		point[0].flagFixed = point[numPoint-1].flagFixed = true;

		if(sin(2.0 * M_PI * time / period) > 0.0)
		{
			point[0].vPos.x += speed * cos(point[0].direction) * timeStep; 
			point[0].vPos.y += speed * sin(point[0].direction) * timeStep; 
		}
		else
		{
			if(d < totalLen+0.01) return ;//RZȂ

			ang = atan2( point[numPoint-5].vPos.y - point[numPoint-1].vPos.y, 
                         point[numPoint-5].vPos.x - point[numPoint-1].vPos.x);
			point[numPoint-1].flagFixed = true;
			point[numPoint-1].vPos.x += speed * cos(ang) * timeStep; 
			point[numPoint-1].vPos.y += speed * sin(ang) * timeStep;
		}
	}
	else if(actionType == 1)//ڎ撎^
	{
		point[0].flagFixed = true;
		point[1].flagFixed = true;
		point[numPoint-1].flagFixed = true;
		point[numPoint-2].flagFixed = true;

		//isωƂ
		double alpha = (point[0].direction - point[0].direction0);
		if(alpha != 0.0)
		{
			for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[numPoint/2].vPos, alpha);
			point[0].direction0 = point[0].direction;
		}

		if(sin(2.0 * M_PI * time / period) > 0.0)
		{
			ang = atan2( point[numPoint/2].vPos.y - point[numPoint-1].vPos.y, 
                         point[numPoint/2].vPos.x - point[numPoint-1].vPos.x);

			point[numPoint-1].vPos.x += speed * cos(ang) * timeStep;
			point[numPoint-1].vPos.y += speed * sin(ang) * timeStep;
			point[numPoint-2].vPos.x += speed * cos(ang) * timeStep;
			point[numPoint-2].vPos.y += speed * sin(ang) * timeStep;
		}

		else
		{
			point[0].vPos.x += speed * cos(point[0].direction) * timeStep;
			point[0].vPos.y += speed * sin(point[0].direction) * timeStep; 
			point[1].vPos.x += speed * cos(point[0].direction) * timeStep;
			point[1].vPos.y += speed * sin(point[0].direction) * timeStep; 
		}
	}
	else if(actionType == 2)//֍s
	{
		point[0].flagFixed = true;
		for(int i = 1; i < numPoint; i++) 
		{
			point[i].flagFixed = false;
		}

		double alpha = (point[0].direction - point[0].direction0);
		if(alpha != 0.0)
		{
			for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[numPoint/2].vPos, alpha);
			point[0].direction0 = point[0].direction;
		}

		float b = 2.0 * M_PI * frequency * time;
		float a = 2.0 * M_PI * frequency * amp ;

		point[0].vPos.x += (speed * cos(point[0].direction) + a * cos(b) * sin(point[0].direction)) * timeStep; 
		point[0].vPos.y += (speed * sin(point[0].direction) - a * cos(b) * cos(point[0].direction)) * timeStep; 

		for(int i = 1; i < numPoint; i++) 
		{
			point[i].vVelocity.x = (speed * cos(point[0].direction) + a * cos(b - delta * (double)i) * sin(point[0].direction)); 
			point[i].vVelocity.y = (speed * sin(point[0].direction) - a * cos(b - delta * (double)i) * cos(point[0].direction)); 
		}

	}
	point[0].direction0 = point[0].direction;
	calcSpringMass(timeStep);

}
