/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ō쐬~`g
GPGPU(vZGPUŎsj
GLSLɂ郌_O
͂
(ݒFx͎OCy͉Ej
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../setupWave.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void rendering();
void setTexturePos();
void setFramebufferPos();
void drawNumberingPoints();
void renewVelocity(float dt);
void renewPosition(float dt);

//͗pf[^̃TCY
int texWidth, texHeight;

//͗pf[^z
float *position;
GLuint texID[1];//texture object
GLuint fb[1];//frame buffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGBA;
GLenum type = GL_FLOAT;
//VF[_vO
GLuint shader_prog1, shader_prog2;

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;
float lengthX0, lengthY0;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("GP_CircularWave");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ĕ`
	glutIdleFunc(idle);
	//ݒ
	glewInit();//framebuffer𗘗pƂɕKv
	init();
	initGlsl(&shader_prog1, "position.vert", "position.frag");
	initGlsl(&shader_prog2, "rendering.vert", "rendering.frag");

	setupGLUI();//myGLUI.hɎ

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	free(position);
	glDeleteTextures(1, texID);
	glDeleteFramebuffersEXT(1, fb);
	glDeleteProgram(shader_prog1);
	glDeleteProgram(shader_prog2);
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);
	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 50.0;
	view.vCnt = CVector(0.0, 0.0, 0.0);
	view.theta = 30.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	glGenTextures(1, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(1, fb);//t[obt@IuWFNg̐


	//\EBhEɕ_O鏀
	setFontBitmaps();

	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;

	//particlȅl쐬
	texWidth  = nSlice0 + 1;//WeNX`̉TCY
	texHeight = nSlice0 + 1;//WeNX`̏cTCY
	
	//ʔz̐錾
	position = (float*)malloc(4 * texWidth * texHeight * sizeof(float));

	//initialize of position
	int i, j, k;
	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * (texWidth);

			//W
			position[k * 4 + 0] = (float)(-nSlice0 / 2.0 + i);//x
			position[k * 4 + 1] = (float)(-nSlice0 / 2.0 + j);//y
			position[k * 4 + 2] = 0.0;                        //z
			position[k * 4 + 3] = 0.0;                        //w
		}

	setTexturePos();
	setFramebufferPos();

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTexturePos()
{//͗p
  glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, position);
  //eNX`gEk@̎w 
  glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  glBindTexture(target, 0);
}

void setFramebufferPos()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	timeStep = timeRate * dt;

	if(flagStart==true && flagFreeze == false)
	{
		//ʒu̍XV
		renewPosition(dt);

		if(flagOneStep) flagFreeze = true;
		elapseTime2 += timeStep;
	}

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	resize(win_width, win_height);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	//_O
	rendering();

	if(flagCoordShow) drawWorldCoordinates(5.0);//[hԂ̍W
	
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", (float)elapseTime2, 400, 30);
	}
	//obt@̐؂ւ
	glutSwapBuffers();	
}

void renewPosition(float dt)
{
	//framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//position
	//VF[_vOL
	glUseProgram(shader_prog1);
	GLint samplerPosLoc = glGetUniformLocation(shader_prog1, "samplerPos");
	glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog1, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint sizeLoc = glGetUniformLocation(shader_prog1, "size");
	glUniform1f(sizeLoc, size0);
	GLint sourceLoc = glGetUniformLocation(shader_prog1, "nSource");
	glUniform1i(sourceLoc, nSource0);
	GLint sourceYLoc = glGetUniformLocation(shader_prog1, "sourceY");
	glUniform1f(sourceYLoc, sourceY0);
	GLint intervalLoc = glGetUniformLocation(shader_prog1, "interval");
	glUniform1f(intervalLoc, interval0);
	GLint ampLoc = glGetUniformLocation(shader_prog1, "amp");
	glUniform1f(ampLoc, amp0);
	GLint freqLoc = glGetUniformLocation(shader_prog1, "freq");
	glUniform1f(freqLoc, freq0);
	GLint lambdaLoc = glGetUniformLocation(shader_prog1, "lambda");
	glUniform1f(lambdaLoc, lambda0);
	GLint timeLoc = glGetUniformLocation(shader_prog1, "time");
	glUniform1f(timeLoc, elapseTime2);
	GLint modeLoc = glGetUniformLocation(shader_prog1, "mode");
	glUniform1i(modeLoc, mode);
	GLint boundaryLoc = glGetUniformLocation(shader_prog1, "boundary");
	glUniform1i(boundaryLoc, boundary);

	drawNumberingPoints();//l͗p̃eNX`iʁj\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);

	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//es̐ݒp
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	//qԍʂ̊eZS_ɓ_`
	glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_W2_ԍ
	glEnd();
}

void rendering()
{
	glUseProgram(shader_prog2);

	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[0]);//position

	GLint samplerPosLoc = glGetUniformLocation(shader_prog2, "samplerPos");
	glUniform1i(samplerPosLoc, 1);//GL_TEXTURE1Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog2, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint texHeightLoc = glGetUniformLocation(shader_prog2, "texHeight");
	glUniform1i(texHeightLoc, texHeight);
	GLint sizeLoc = glGetUniformLocation(shader_prog2, "size");
	glUniform1f(sizeLoc, size0);

	static float diffuse[] = { 0.4f, 0.6f, 0.9f, 1.0f} ;
	static float ambient[] = { 0.1f, 0.2f, 0.3f, 1.0f};
	static float specular[]= { 1.0f, 1.0f, 1.0f, 1.0f};

	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,10.0);

	if(flagWireframe == 0)
		drawGridPlate((float)nSlice0, (float)nSlice0, nSlice0, nSlice0);
	else
		drawGridLines((float)nSlice0, (float)nSlice0, nSlice0, nSlice0);

	glUseProgram(0);
}

