const float pi = 3.14159265;
uniform sampler2DRect samplerPos;
uniform int texWidth, texHeight;
uniform float size;

varying vec3 P;
varying vec3 N;
varying vec3 T;//ڐxNg
varying vec3 B;//]@xNg
varying vec2 grad;

//eNX`WԂɂfʒu̒P
float delta = 0.1;//Ԋu

void main(void)
{
	vec2 texPos = gl_Vertex.xy + vec2(float((texWidth)/2), float((texHeight)/2));

	//ʒuW
	vec4 position = texture2DRect(samplerPos, texPos);
	//x
	vec4 position1 =  texture2DRect(samplerPos, texPos+vec2(-delta, 0.0));
	vec4 position2 =  texture2DRect(samplerPos, texPos+vec2( delta, 0.0));
	grad.x = (position2.z - position1.z) / (2.0 * delta);
	//y
	position1 =  texture2DRect(samplerPos, texPos+vec2(0.0,-delta));
	position2 =  texture2DRect(samplerPos, texPos+vec2(0.0, delta));
	grad.y =  (position2.z - position1.z) / (2.0 * delta);
	//1ӂ̒sizeɕϊ
 	gl_Vertex.x = gl_Vertex.x * size /  float(texWidth);
	gl_Vertex.y = gl_Vertex.y * size /  float(texHeight);
	gl_Vertex.z = position.z;

	P = vec3(gl_ModelViewMatrix * gl_Vertex);
	N = normalize(gl_NormalMatrix * gl_Normal).xyz;
	//ڐxNg
	T = normalize(gl_NormalMatrix * vec3(1.0, 0.0, 0.0)).xyz;
	//]@xNg
	B = cross( N, T);
	
	gl_Position = ftransform();
}
