#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerWave;
uniform int texWidth;//_~[܂ޑSiq
uniform int nDummy;
uniform int nSlice0;
uniform float size0;
varying vec3 P;
varying vec3 N;
varying vec3 T;//ڐxNg
varying vec3 B;//]@xNg
varying vec2 grad;

//eNX`WԂɂfʒu̒P
float delta = 0.1;//Ԋu
int texHeight = texWidth;
void main(void)
{
	//eNX`W̒Sړ
	vec2 texPos = gl_Vertex.xy + vec2(float(texWidth/2), float(texHeight/2));

	//ʒuW
	vec4 wave = texture2DRect(samplerWave, texPos);
	//x
	vec4 wave1 =  texture2DRect(samplerWave, texPos+vec2(-delta, 0.0));
	vec4 wave2 =  texture2DRect(samplerWave, texPos+vec2( delta, 0.0));
	grad.x = (wave2.g - wave1.g) / (2.0 * delta);
	//y
	wave1 =  texture2DRect(samplerWave, texPos+vec2(0.0,-delta));
	wave2 =  texture2DRect(samplerWave, texPos+vec2(0.0, delta));
	grad.y =  (wave2.g - wave1.g) / (2.0 * delta);
	//1ӂ̒size0ɕϊ
 	gl_Vertex.x *= size0 /  float(nSlice0);
	gl_Vertex.y *= size0 /  float(nSlice0);
	gl_Vertex.z = wave.g;//gl

	P = vec3(gl_ModelViewMatrix * gl_Vertex);
	N = normalize(gl_NormalMatrix * gl_Normal).xyz;
	//ڐxNg
	T = normalize(gl_NormalMatrix * vec3(1.0, 0.0, 0.0)).xyz;
	//]@xNg
	B = normalize(gl_NormalMatrix * vec3(0.0, 1.0, 0.0)).xyz;
		
	gl_Position = ftransform();
}
