/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ʉ]
]nɂ^
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigid3D.h"
#include "../../setup3D.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();
void initObject();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//VF[_vO
GLuint shaderProg;

float damping0 = 0.5;//]W
float radius0 = 10.0;//~Տɒuꂽ̂̉~ՒS̋
float angle0 = 0.0;//]px
CVector vRotPos[202] ;//]nW
bool flagShooted = false;
CVector vCenter;
CVector vVelT, vDir;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_Turntable2");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.7, 0.7, 0.75, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύX
	view.dist= 40.0;
	view.vCnt = CVector(0.0, 0.0, 5.0);
	view.theta = 40.0;
	view.phi = 0.0;
	setCamera();
	view.fovY = 40.0;
	view.nearZ = 1.0;
	view.farZ = 200.0;
	view0 = view;

	restitut = 0.2;//restitution
	muK = 0.2;     //kinetic friction
	muS = 1.0;     //static friction
	flagMagnus = 0;
	flagDrag = 0;
	flagTumbling = 0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();
  
	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	createDisplayListsPet();
	createDisplayListsVehicle();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");

}

void initObject()
{
	flagFreeze = false;
	flagShoot = false;
	flagShooted = false;

	countStrobo = 0;
	timeStrobo = 0.0;
	restValue = 0.0;
	dampingR = damping0;//ʏ̉]W

	//~Ղ̒S
	vCenter = CVector(-(size0+1.0)/2.0, 0.0, radius0 + 3.0);
	if(flagRotCoord)
	{
		view.vCnt = vCenter;
		view.theta = 0.0;
		setCamera();
	}
	else 
	{
		view.dist= 40.0;
		view.vCnt = CVector(0.0, 0.0, 10.0);
		view.theta = 10.0;
		view.phi = 0.0;
		view.fovY = 40.0;
		view.nearZ = 1.0;
		view.farZ = 200.0;
		setCamera();
	}

	//̂̏ݒ
	numRigid0 = 2;
	numRigid = numRigid0 + numStrobo;//100̓Xg{p
	selNo = 0;
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();

	angle0 =  0.0;
	//]̕
	rigid[0].kind = BOX;//SPHERE;
	rigid[0].mass = mass0;
	rigid[0].vSize = CVector(1.0, 1.0, 1.0) * size0;
	rigid[0].vPos = CVector(0.0, 0.0,  3.0);
	//]
	rigid[1].kind = COLUMN;
	rigid[1].color = DARK_YELLOW;
	rigid[1].mass = 100.0;//C
	rigid[1].vSize =  CVector(2.0 * radius0 + 2.0, 2.0 * radius0 + 2.0, 1.0);
	rigid[1].vPos = vCenter;
	rigid[1].vVelocity = CVector(0.0, 0.0, 0.0);
	rigid[1].vOmega = CVector(omega, 0.0, 0.0) * 2.0 * M_PI;//
	rigid[1].vEuler = CVector(0.0, 90.0, 0.0);
	rigid[1].q = getQFromEulerZYX(rigid[1].vEuler) * rigid[1].q;//Ԃɂ]

	rigid[0].ready();
	rigid[1].ready();

	for(i = numRigid0; i < numRigid; i++) {
		rigid[i].color = CYAN;
		rigid[i].vSize = CVector(0.3, 0.3, 0.3);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		 vRotPos[i] = CVector(1000.0, 1000.0, 1000.0);
	}
}

void setTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();

	if(flagRotCoord)
	{
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, -sin(angle0), cos(angle0));
	}
	else
	{
		if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
			gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
		else
			gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);
	}
	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
		glPolygonMode(GL_FRONT,GL_LINE);
		glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	
	for(int i = 0; i < numRigid0; i++)
	{
		if(i == selNo)
		{
			glUniform1i(selLoc, 1);
			rigid[i].select = true;
		}
		else
		{
			glUniform1i(selLoc, 0);
			rigid[i].select = false;
		}
		rigid[i].draw(false);
	}
	float yy, zz;
	if(flagStrobo) 
	{
		for(int i = numRigid0; i < numRigid; i++) 
		{
			glUniform1i(selLoc, 0);

			if(flagRotCoord){ 
				rigid[i].vPos.x = vRotPos[i].x;
				yy = vRotPos[i].y; zz = vRotPos[i].z;// + vCenter.z;
				//]Wn̈ʒux]ăEBhEɌŒ(angle0͕\Ă錻݂̊pxj
				rigid[i].vPos.y = yy * cos(angle0) - zz * sin(angle0);
				rigid[i].vPos.z = yy * sin(angle0) + zz * cos(angle0) + vCenter.z;
			}
			rigid[i].draw(false);
		}
	}

	glUseProgram(0);

	float timeStep = timeRate * dt;
	
	if(flagStart == true && flagFreeze == false) 
	{
		elapseTime2 += timeStep;
		angle0 += rigid[1].vOmega.x * timeStep;
		if(!flagShoot)
		{
			rigid[0].vOmega = rigid[1].vOmega;
			rigid[0].vVelocity = vCross(rigid[1].vOmega, rigid[0].vPos - CVector(0.0, 0.0, vCenter.z));
			rigid[0].vPos += rigid[0].vVelocity * timeStep;
			vVelT = rigid[0].vVelocity;//ڐx
		}
		else
		{
			if(!flagShooted)//˂̏uԂ
			{
				vDir = CVector(0.0, 0.0, vCenter.z) -  rigid[0].vPos ;//~Ղ̒S֔
				vDir.norm();
				rigid[0].vVelocity = vVelT + speedShoot * vDir;//x
				flagShooted = true;
			}
		}
		//~Ղ̒SŒ
		rigid[1].vPos = vCenter;
		rigid[1].action3D(timeStep);
		if(flagShoot) rigid[0].action3D(timeStep);//^
		
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				if(flagRotCoord) 
				{//]n
					vRotPos[numRigid0 + countStrobo].x = rigid[0].vPos.x;
					//]Wn̈ʒuɕϊ(x])
					vRotPos[numRigid0 + countStrobo].y = rigid[0].vPos.y * cos(angle0) + (rigid[0].vPos.z-vCenter.z) * sin(angle0);
					vRotPos[numRigid0 + countStrobo].z = -rigid[0].vPos.y * sin(angle0) + (rigid[0].vPos.z-vCenter.z) * cos(angle0);
				}
				else  rigid[numRigid0 + countStrobo].vPos = rigid[0].vPos;//n
			}

			timeStrobo += timeStep;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = numStrobo;
		}
	}

	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(5.0);              //[hԂ̍W
		drawInertialCoordinates(rigid[0], 2.0); //Ԃ̍W
		drawObjectCoordinates(rigid[0], 2.0);   //IuWFNgԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/(float)fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", (float)elapseTime2, 400, 30);
		drawParam("speedT=%3.2f[s]", (float)vVelT.magnitude2(), 10, 60);
		drawParam("speedS=%3.2f[s]", speedShoot, 200, 60);
	}

	if(flagTrack)
	{
		view.vCnt.x = rigid[selNo].vPos.x;
		view.vCnt.y = rigid[selNo].vPos.y;
		setCamera();
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}
