/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

^
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigid3D.h"
#include "../../collision3D.h"
#include "../../setup3D.h"
#include "myGLUI.h"
//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//VF[_vO
GLuint shaderProg;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_Collision");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.7, 0.7, 0.75, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύX
	view.dist= 50.0;
	view.vCnt = CVector(0.0, 0.0, 5.0);
	view.theta = 0.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;

	//parameter
	restitut = 0.2;//restitution
	muK = 0.5;     //dynamic friction
	restValue = 0.5;
	cSpring = 0.0;
	dampingR = 1.0;
	flagDrag = 0;
	flagMagnus = 0;
	flagTumbling = 0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();
  
	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	createDisplayListsPet();
	createDisplayListsVehicle();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");

}

void initObject()
{
	elapseTime2 = 0.0;//start̑oߎ
	flagFreeze = false;
	flagOneStep = false;

	countStrobo = 0;
	timeStrobo = 0.0;

	//̂̏ݒ
	numRigid0 = 2;
	numRigid = numRigid0 + numStrobo;
	selNo = 0;
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();

	rigid[0].kind = (Kind)kind0;//CUBE;
	rigid[0].mass = mass0;
	rigid[0].color = YELLOW;
	rigid[0].vPos = CVector(posX0, posY0, posZ0);
	rigid[0].vSize = CVector(1.0, 1.0, 1.0) * size0;
	rigid[0].vVelocity = CVector(0.0, velY0, 0.0);
	rigid[0].vOmega = CVector(omegaX0, 0.0, omegaZ0) * 2.0 * M_PI;//[rps]->[rad/s]
	rigid[0].vEuler = CVector(angX0, angY0, angZ0);
	rigid[0].q = getQFromEulerXYZ(rigid[0].vEuler);//Ԃɂ]
	rigid[0].select = 1;
	rigid[0].ready();

	rigid[1].kind = (Kind)kind1;
	rigid[1].color = CYAN;
	rigid[1].vPos = CVector(posX1, posY1, posZ1);
	rigid[1].vSize = CVector(1.0, 1.0, 1.0) * size1;
	rigid[1].vVelocity = CVector(0.0, velY1, 0.0);
	rigid[1].vOmega = CVector(omegaX1, 0.0, omegaZ1) * 2.0 * M_PI;
	rigid[1].vEuler = CVector(angX1, angY1, angZ1);
	rigid[1].q = getQFromEulerXYZ(rigid[1].vEuler);//Ԃɂ]
	rigid[1].ready();
	rigid[1].select = 0;

	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		if(((i-numRigid0) / 2) * 2 == i - numRigid0) 
		{
			rigid[i].color = DARK_YELLOW;
			rigid[i].vSize = CVector(0.3, 0.3, 0.3);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
		else if(((i-numRigid0) / 2) * 2 + 1 == i - numRigid0)
		{
			rigid[i].color = DARK_CYAN;
			rigid[i].vSize = CVector(0.3, 0.3, 0.3);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
	}

}

void setTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
		glPolygonMode(GL_FRONT,GL_LINE);
		glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");

	for(int i = 0; i < numRigid0; i++)
	{
		if(i == selNo) {glUniform1i(selLoc, 1); rigid[i].select = 1;}
		else           {glUniform1i(selLoc, 0); rigid[i].select = 0;}
		rigid[i].draw(false);
	}
	glUniform1i(selLoc, 0);

	if(flagStrobo) 
	{
		for(int i = numRigid0; i < numRigid; i++)
		{
			rigid[i].select = false;
			rigid[i].draw(false);
		}
	}

	glUseProgram(0);

	double timeStep = timeRate * dt;
	if(flagStart == true && flagFreeze == false) 
	{
		elapseTime2 += timeStep;//start̑oߎ
		collision(timeStep);//collision3D1.h
		if(flagOneStep) flagFreeze = true;
		
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				if((countStrobo/2) * 2 == countStrobo) rigid[numRigid0 + countStrobo].vPos = rigid[0].vPos;
				else                                   rigid[numRigid0 + countStrobo].vPos = rigid[1].vPos;
			}

			timeStrobo += timeStep;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
		}
	}


	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(5.0);              //[hԂ̍W
		drawInertialCoordinates(rigid[0], 2.0); //Ԃ̍W
		drawObjectCoordinates(rigid[0], 2.0);   //IuWFNgԂ̍W
	}
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/(float)fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", (float)elapseTime2, 400, 30);
	}

	if(flagTrack)
	{
		view.vCnt.x = rigid[selNo].vPos.x;
		view.vCnt.y = rigid[selNo].vPos.y;
		setCamera();
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}


