/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

1ol_f̔g
IC[@
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../rigidSM.h"
#include "../../spring_mass1.h"
#include "../../setupSM1.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

double heightFix0 = 2.0;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_SpringMass1_2");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 6.0;
	view.vCnt = CVector(0.0, 0.0, 1.5);
	view.theta = 10.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	muK = 0.0;
	restitut = 0.0;
	viscous = 0.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	printf("}EX͎_Ɏgp \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;

	numHinge = numSpring = numSpring0;
	if(sm1.boundary == B_NON) numDummy = 30;
	else numDummy = 0;

	sm1.damping = damping;
	sm1.drag = drag0;
	sm1.mass = mass;          //KgPʁi_Pj
	sm1.constK = constK0;     //olPiŜ1/numSpring)
	sm1.length0 = length0;    //R(ol1j
	sm1.totalLen = totalLen;
	sm1.frequency = frequency;//M̎
	sm1.amp = amp;            //M̐U

	sm1.vPos = CVector(0.0, -sm1.totalLen / 2.0, 0.0);
	numPoint = numSpring + 1;
	numPole = 2;
	for(int i = 0; i < numSpring + numDummy; i++) sm1.spring[i] = CSpring();
	for(int i = 0; i < numPoint + numDummy; i++) sm1.point[i] = CRigid();
	for(int i = 0; i < numPole; i++) sm1.pole[i] = CRigid();
	sm1.height0 = 1.0;
	sm1.radius = radius;
	sm1.initialize();
	
    for(int i = 0; i < numPoint; i++){
		sm1. point[i].kind = SPHERE;
        sm1.point[i].vSize = CVector(4.0*sm1.radius, 2.0*sm1.radius, 4.0*sm1.radius);
	}

	if(sm1.boundary == B_FIXED)
	{
		sm1.point[0].flagFixed = true;
		sm1.point[numPoint-1].flagFixed = true;
	}
	else
	{
		sm1.point[0].flagFixed = false;
		sm1.point[numPoint-1].flagFixed = false;
	}
	//|[0([j
	sm1.pole[0].vSize = CVector(0.05, 0.05, sm1.height0);
	sm1.pole[0].vPos = sm1.vPos + CVector(0.0, 0.0, sm1.height0 / 2.0);
	sm1.pole[0].kind = CYLINDER;
	sm1.pole[0].color = YELLOW;

	//|[1(E[j
	sm1.pole[1].vSize = CVector(0.05, 0.05, sm1.height0);
	sm1.pole[1].vPos = sm1.vPos + CVector(0.0, sm1.totalLen, sm1.height0 / 2.0);
	sm1.pole[1].kind = CYLINDER;
	sm1.pole[1].color = YELLOW;
	sm1.pole[1].flagFixed = true; 

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");
	glUniform1i(selLoc, 0);

	sm1.draw(false);
	glUseProgram(0);

	timeStep = timeRate * dt;
	double omega = 2.0 * M_PI * sm1.frequency;//ŮpU
	double period = 1.0 / sm1.frequency;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		double tt = timeStep / 10.0;
		double time = elapseTime2;
		for(int j = 0; j < 10; j++)
		{
			if(sm1.motion == TRANSVERSE)
			{
				if(sm1.mode == SINGLE)
				{
					if(time < period / 2.0)
						sm1.point[0].vPos.z = sm1.height0 + sm1.amp * sin(omega * time);
				}
				else{
					sm1.point[0].vPos.z = sm1.height0 + sm1.amp * sin(omega * time);
				}
				sm1.testTransverseWave(tt);
			}
			else if(sm1.motion == LONGITUDE)
			{
				if(sm1.mode == SINGLE)
				{
					if(time < period / 2.0)
						sm1.point[0].vPos.y = sm1.vPos.y + sm1.amp * sin(omega * time);
				}
				else{
					sm1.point[0].vPos.y = sm1.vPos.y + sm1.amp * sin(omega * time);
				}

				sm1.testLongitudinalWave(tt);
			}
			else//g 
			{
				if(sm1.mode == SINGLE)
				{
					if(time < period / 2.0){
						sm1.point[0].vPos.z = sm1.height0 + sm1.amp * sin(omega * time);
					}
				}
				else{
					sm1.point[0].vPos.z = sm1.height0 + sm1.amp * sin(omega * time);
				}
				sm1.testHybridWave(tt);
			}
			time += tt;
		}
		if(flagOneStep) flagFreeze = true;
		elapseTime2 += timeStep;
	}

	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5);   //[hԂ̍W
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}

