//collision.h
//2oX_fƍ̋̏Փ

void collisionWithRigid(int i, int j, float dt);
//float checkCollision(int i, CRigid rigid, CVector &vNormal);

void collision(float dt)
{
	int i, j;

	float d;// = vDist(sm2.vPos, sm2.rigid2.vPos);
	//if(d > (sm2.vSize.z + sm2.rigid2.boundingR) / 2.0) return;

	for(j = 0; j < sm2.numCol; j++)
	for(i = 0; i < sm2.numRow; i++)
	{   
		d = vDist(sm2.point[i][j].vPos,  sm2.rigid2.vPos);
		if( d > sm2.pointRadius + sm2.rigid2.vSize.x / 2.0) continue;
		collisionWithRigid(i, j, dt);
	}

}
//--------------------------------------------------------------------------
void collisionWithRigid(int i, int j, float dt)
{
	float rikiseki;
	float vn1, vn2;//@̑傫
	float muc, B, m1, m2;
	CVector vVelocityP1, vVelocityP2;//x
	CVector vNormal;//ڍ(_)猩Փ˖ʂ̖@
	CVector vTangential;//ڐ
	CVector vDir, vA1, vA2, vRg1, vRg2;

	sm2.point[i][j].vForce = CVector();
	sm2.point[i][j].vTorque = CVector();
	sm2.rigid2.vForce = CVector();
	sm2.rigid2.vTorque = CVector();

	vNormal = sm2.point[i][j].vPos >> sm2.rigid2.vPos;
	//dSՓ˓_܂ł̃xNg
	sm2.point[i][j].vGravityToPoint = (sm2.pointRadius) * vNormal;
	sm2.rigid2.vGravityToPoint = (sm2.rigid2.vSize.x/2.0) * vNormal;
	sm2.rigid2.vGravityToPoint.reverse();
	float depth = (sm2.pointRadius + sm2.rigid2.vSize.x / 2.0) - vDist(sm2.point[i][j].vPos, sm2.rigid2.vPos);

	//float depth = checkCollision(i, sm2.rigid2, vNormal);
//printf("depth=%f \n", depth);
	if(depth < 0.0) return;
	vRg1 = sm2.point[i][j].vGravityToPoint;
	vRg2 = sm2.rigid2.vGravityToPoint;
	m1 = sm2.point[i][j].mass;
	m2 = sm2.rigid2.mass;

	vVelocityP1 = sm2.point[i][j].vVelocity + vCross(sm2.point[i][j].vOmega, vRg1);
	vn1 = vDot(vVelocityP1, vNormal);
	vVelocityP2 =sm2.rigid2.vVelocity + vCross(sm2.rigid2.vOmega, vRg2);
	vn2 = vDot(vVelocityP2, vNormal);

	//Փˉ
	vTangential = vCross( vNormal, vCross((vVelocityP1 - vVelocityP2), vNormal));
	vTangential.norm();
	//͐
	rikiseki = - (restitut + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2
		  + vDot(vNormal , vCross((sm2.point[i][j].mInertiaInverse * vCross(vRg1, vNormal)), vRg1))
		  + vDot(vNormal , vCross((sm2.rigid2.mInertiaInverse * vCross(vRg2, vNormal)), vRg2)));
	//͂̑a
	sm2.point[i][j].vForce += (vNormal) * rikiseki / dt;
	sm2.rigid2.vForce -= (vNormal) * rikiseki / dt;
	//͂̃[gigNj̑a
	sm2.point[i][j].vTorque += vCross(vRg1, vNormal) * rikiseki / dt;
	sm2.rigid2.vTorque -= vCross(vRg2, vNormal) * rikiseki / dt;

	//Cl
	vA1 = vCross(((sm2.point[i][j].mInertiaInverse * vCross(vRg1, vTangential))) , vRg1);
	vA2 = vCross(((sm2.rigid2.mInertiaInverse * vCross(vRg2, vTangential))) , vRg2);
	B = - vDot(vTangential, (vVelocityP1-vVelocityP2)) / (1.0f/m1+1.0f/m2+ vDot(vTangential,(vA1+vA2)));
	muc = fabs(B / rikiseki);
	if(muK >= muc)
	{
		sm2.point[i][j].vForce +=  vTangential* B / dt;
		sm2.point[i][j].vTorque += vCross(vRg1, vTangential) * B / dt;
		sm2.rigid2.vForce -=  vTangential* B / dt;
		sm2.rigid2.vTorque -= vCross(vRg2, vTangential) * B / dt;
	}
	else
	{
		sm2.point[i][j].vForce +=  muK * (rikiseki / dt) * vTangential;
		sm2.point[i][j].vTorque += vCross(vRg1, vTangential) * muK * rikiseki / dt;
		sm2.rigid2.vForce -=  muK * (rikiseki / dt) * vTangential;
		sm2.rigid2.vTorque -= vCross(vRg2, vTangential) * muK * rikiseki / dt;
	}
	//Փ˔莞ɂ߂荞񂾕
	sm2.point[i][j].vPos -= (depth/2.0) * vNormal;				
	sm2.rigid2.vPos += (depth/2.0) * vNormal;


	//ʒu]px̍XV
	// iԖڂ̍
	sm2.point[i][j].vAccel = sm2.point[i][j].vForce / m1;    //x
	sm2.point[i][j].vVelocity += sm2.point[i][j].vAccel * dt;//x
	sm2.point[i][j].vAlpha = sm2.point[i][j].mInertiaInverse * sm2.point[i][j].vTorque;//px̍XV
	sm2.point[i][j].vOmega += sm2.point[i][j].vAlpha * dt;          //px

	// jԂ̍
	sm2.rigid2.vAccel =sm2.rigid2.vForce / m2;
	sm2.rigid2.vVelocity +=sm2.rigid2.vAccel * dt;
	sm2.rigid2.vAlpha = sm2.rigid2.mInertiaInverse *sm2.rigid2.vTorque;
	sm2.rigid2.vOmega +=sm2.rigid2.vAlpha * dt;

}
