
#include "../../spring.h"

//int flagCollision = 1;//ՓˏL/
int numPoint;
int type = 0;
int mode = 0;
int rootNo;

class CSpringMass
{
public:
    CVector vPos;
	float speed;//isx
    //CVector vEuler;
	float mass;//_P̎
    float constK;
	float drctnK;
	float damping;
	float drag;
    float length0;  //sprinĝP莩R
    float radius ;//a
	float direction, direction0;//isix̌oxCdegj
	double theta1;//OXp

    CVector vForce0;//O͂̏l
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];
	CRigid pole[2];

    //o֐
    CSpringMass();
    void draw(bool flagShadow);
    void create();
    void calcSpringMass(double dt);
	void action0(double dt, double time);
	void action1(double dt, double time);
private:
};
CSpringMass sm;
//---------------------------------------------------------------
CSpringMass::CSpringMass()
{
    vPos = CVector();
    length0 = 1.0;
	constK = 1000.0;
	drctnK = 100.0;
	mass = 1.0;
	drag = 0.0;
	damping = 0.0;
    radius = 0.03;
	theta1 = 20.0;//OXp
	//theta2 = -10.0;//Xp
	vForce0 = CVector();
}
//-----------------------------------------------------------------
void CSpringMass::draw(bool flagShadow)
{
    int i;
    int r1, r2;

    //΂ˎ_\
    //_
    for(i = 0; i < numPoint; i++) {
        point[i].color = CYAN;
        if(point[i].flagFixed == true){
            //point[i].color= RED;
        }
        point[i].draw(flagShadow);
    }
    for(i = 0; i < numSpring; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }
}
//-----------------------------------------------------------------
void CSpringMass::create()
{
	if(type == 0)
	{
		numSpring = 10;
		numPoint = 11;
		float wid = 0.2 * length0;
		float wid1 = 0.3 * length0;
		rootNo = 4;

		//point
		//
		point[0].vPos = CVector(-wid, 0.0, radius) + vPos;//
		point[1].vPos = CVector( wid, 0.0, radius) + vPos;//E
		//
		point[2].vPos = CVector(-wid, 0.0, radius + length0) + vPos;//
		point[3].vPos = CVector( wid, 0.0, radius + length0) + vPos;//E
		//dSirootj
		point[4].vPos = CVector( 0.0, 0.0, radius + length0) + vPos;
		//,
		point[5].vPos = CVector( 0.0, 0.0, radius + 1.9*length0) + vPos;
		point[6].vPos = CVector( 0.0, 0.0, radius + 2.3*length0) + vPos;
		//
		point[7].vPos = CVector(-wid1, 0.0, radius + 1.9*length0) + vPos;
		point[8].vPos = CVector( wid1, 0.0, radius + 1.9*length0) + vPos;
		//
		point[9].vPos =  CVector(-wid1, 0.0, radius + length0 * 0.9) + vPos;
		point[10].vPos = CVector( wid1, 0.0, radius + length0 * 0.9) + vPos;
		//spring
		//r(spring)
		spring[0].row1 = 0; spring[0].row2 = 2;//r
		spring[1].row1 = 1; spring[1].row2 = 3;//Er
		//(spring)
		spring[2].row1 = 2; spring[2].row2 = 4;//
		spring[3].row1 = 4; spring[3].row2 = 3;//E
		//́iwj
		spring[4].row1 = 4; spring[4].row2 = 5;
		//
		spring[5].row1 = 5; spring[5].row2 = 6;
		//
		spring[6].row1 = 7; spring[6].row2 = 5;
		spring[7].row1 = 5; spring[7].row2 = 8;
		//r
		spring[8].row1 = 7; spring[8].row2 = 9;
		spring[9].row1 = 8; spring[9].row2 = 10;
	}
	else if(type == 1)
	{
		numSpring = 14;
		numPoint = 15;
		float wid = 0.2 * length0;
		float wid1 = 0.3 * length0;
		rootNo = 6;
		//point
		//
		point[0].vPos = CVector(-wid, 0.0, radius) + vPos;//
		point[1].vPos = CVector( wid, 0.0, radius) + vPos;//E
		//G
		point[2].vPos = CVector(-wid, 0.0, radius + length0/2.0) + vPos;//
		point[3].vPos = CVector( wid, 0.0, radius + length0/2.0) + vPos;//E
		//
		point[4].vPos = CVector(-wid, 0.0, radius + length0) + vPos;//
		point[5].vPos = CVector( wid, 0.0, radius + length0) + vPos;//E
		//dSirootj
		point[6].vPos = CVector( 0.0, 0.0, radius + length0) + vPos;
		//,
		point[7].vPos = CVector( 0.0, 0.0, radius + 2.0*length0) + vPos;
		point[8].vPos = CVector( 0.0, 0.0, radius + 2.3*length0) + vPos;
		//
		point[9].vPos  = CVector(-wid1, 0.0, radius + 2.0*length0) + vPos;
		point[10].vPos = CVector( wid1, 0.0, radius + 2.0*length0) + vPos;
		//I
		point[11].vPos = CVector(-wid1, 0.0, radius + length0 * 1.6) + vPos;
		point[12].vPos = CVector( wid1, 0.0, radius + length0 * 1.6) + vPos;
		//
		point[13].vPos = CVector(-wid1, 0.0, radius + length0 * 1.1) + vPos;
		point[14].vPos = CVector( wid1, 0.0, radius + length0 * 1.1) + vPos;
		//spring
		//(spring)
		spring[0].row1 = 0; spring[0].row2 = 2;//
		spring[1].row1 = 1; spring[1].row2 = 3;//E
		//(spring)
		spring[2].row1 = 2; spring[2].row2 = 4;//
		spring[3].row1 = 3; spring[3].row2 = 5;//E
		//(spring)
		spring[4].row1 = 4; spring[4].row2 = 6;//
		spring[5].row1 = 6; spring[5].row2 = 5;//
		//́iwj
		spring[6].row1 = 6; spring[6].row2 = 7;
		//
		spring[7].row1 = 7; spring[7].row2 = 8;
		//
		spring[8].row1 = 9; spring[8].row2 = 7;
		spring[9].row1 = 7; spring[9].row2 = 10;
		//r
		spring[10].row1 = 9;  spring[10].row2 = 11;
		spring[11].row1 = 10; spring[11].row2 = 12;
		//Or
		spring[12].row1 = 11; spring[12].row2 = 13;
		spring[13].row1 = 12; spring[13].row2 = 14;
	}
	//ol̎RƕxNg
	int n1, n2;
	for(int i = 0; i < numSpring; i++)
	{
		n1 = spring[i].row1; n2 = spring[i].row2;
		spring[i].length0 = vDist(point[n1].vPos, point[n2].vPos);
		spring[i].vDir0 = point[n1].vPos >> point[n2].vPos;
	}

    //_̃TCY,
    for(int i = 0; i < numPoint; i++){
        point[i].kind = SPHERE;
		point[i].vSize = CVector(2.0, 2.0, 2.0) * radius;
		point[i].mass = mass;
        point[i].vSize = CVector(2.0*radius, 2.0*radius, 2.0*radius);
    }
	//ol
    for(int i = 0; i < numSpring; i++){
		spring[i].radius = radius;
        spring[i].kind = S_CYLINDER;
	}

	//islyłȂƂ_̈ʒu/ol̕xNgς
	double alpha = direction - M_PI/2.0;
	if(alpha != 0.0)
	{
		for(int i = 0; i < numSpring; i++) spring[i].vDir0.rotZ_rad(alpha);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
	}
}

//-----------------------------------------------------------------------------
//1̃ol}Xf(hinge springlCRԂŉ^)
void CSpringMass::calcSpringMass(double dt)
{                                           
    int i, r1, r2;
    CVector vDir1, vDir2;
    CVector vFF, vRelativeVelocity;
    float dampingF;
	double angle;
    CVector vNormal;

	//͂̑a
    //ݒl
    for(i = 0; i  < numPoint; i++)
        point[i].vForce = point[i].vForce0 + CVector(0.0, 0.0, -gravity * mass);

	//olɂ
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (spring[i].length - spring[i].length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

	//oll
	for(i = 0; i < numSpring; i++)
	{
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;
        vNormal = vCross(spring[i].vDir0, vDir1);
		vDir2 = vCross(vNormal, vDir1);
		angle = getAngle(spring[i].vDir0, vDir1);
        vFF = drctnK * angle * vDir2 / spring[i].length;
        point[r2].vForce -= vFF ;
        point[r1].vForce += vFF;//vDir2Ɠ
	}


    //SRƏʏ,lvZ
    for(i = 0; i < numPoint; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

		//ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
		point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
        point[i].vPos += point[i].vVelocity * dt;
    }
	vPos = point[rootNo].vPos;
}

//----------------------------------------------------------------------------------
void CSpringMass::action0(double timeStep, double time)
{
	int i;
	double theta, dist;
	double thetaDegL, thetaDegR;
	CVector vDirection = CVector(cos(direction), sin(direction), 0.0);//is̃xNg

	//r̐it,獘j
	dist = vDot(point[2].vPos - point[0].vPos, vDirection);
	//r̊px
	theta = atan2(dist, point[2].vPos.z - point[0].vPos.z); 
	thetaDegL = theta * RAD_TO_DEG;
	//Er̐it,獘j
	dist = vDot(point[3].vPos - point[1].vPos, vDirection);
	//Er̊px
	theta = atan2(dist, point[3].vPos.z - point[1].vPos.z); 
	thetaDegR = theta * RAD_TO_DEG;

	for(i = 2; i < numPoint; i++)
	{
		point[i].vVelocity.x = speed * cos(direction);
		point[i].vVelocity.y = speed * sin(direction);
	}

	if(mode == 0)
	{//ŒCE/o,
		point[0].flagFixed = true;
		point[1].flagFixed = false;
		point[1].vVelocity.x = 2.0*speed * cos(direction);
		point[1].vVelocity.y = 2.0*speed * sin(direction);
		point[9].vVelocity.x = 2.0*speed * cos(direction);
		point[9].vVelocity.y = 2.0*speed * sin(direction);
		point[10].vVelocity.x = 0.0;
		point[10].vVelocity.y = 0.0;
		if(thetaDegL > theta1) mode = 1;
	}
	else if(mode == 1)
	{//EŒC/Eo
		point[0].flagFixed = false;
		point[1].flagFixed = true;
		point[0].vVelocity.x = 2.0*speed * cos(direction);
		point[0].vVelocity.y = 2.0*speed * sin(direction);
		point[10].vVelocity.x = 2.0*speed * cos(direction);
		point[10].vVelocity.y = 2.0*speed * sin(direction);
		point[9].vVelocity.x = 0.0;
		point[9].vVelocity.y = 0.0;
		if(thetaDegR > theta1) mode = 0;
//printf("thetaDegL=%f, thetaDegR=%f \n", thetaDegL, thetaDegR);
	}

	//isωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;
	if(alpha != 0.0)
	{
		//ol̕
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ_rad(alpha);
		//_̍W
		for(i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
	}
	direction0 = direction;

	calcSpringMass(timeStep);
}

//----------------------------------------------------------------------------------
void CSpringMass::action1(double timeStep, double time)
{
	int i;
	double theta, dist;
	double thetaDegL, thetaDegR;
	CVector vDirection = CVector(cos(direction), sin(direction), 0.0);//is̃xNg

	//r̐itj
	dist = vDot(point[4].vPos - point[0].vPos, vDirection);
	//r̊px
	theta = atan2(dist, point[4].vPos.z - point[0].vPos.z); 
	thetaDegL = theta * RAD_TO_DEG;
	//Er̐itj
	dist = vDot(point[5].vPos - point[1].vPos, vDirection);
	//Er̊px
	theta = atan2(dist, point[5].vPos.z - point[1].vPos.z); 
	thetaDegR = theta * RAD_TO_DEG;

//printf("left=%f  right=%f \n", thetaDegL, thetaDegR);

	for(i = 4; i < numPoint; i++)
	{
		point[i].vVelocity.x = speed * cos(direction);
		point[i].vVelocity.y = speed * sin(direction);
	}

	if(mode == 0)
	{//ŒCE/o,
		point[0].vPos.z = radius;//nʂɕt
		point[0].flagFixed = true;
		point[1].flagFixed = false;
		point[1].vVelocity.x = 2.0*speed * cos(direction);
		point[1].vVelocity.y = 2.0*speed * sin(direction);
		point[3].vVelocity.x = 2.0*speed * cos(direction);
		point[3].vVelocity.y = 2.0*speed * sin(direction);
		point[3].vForce0.z = 150.0 * mass;//EЂ
		point[13].vVelocity.x = 2.3*speed * cos(direction);
		point[13].vVelocity.y = 2.3*speed * sin(direction);
		point[14].vVelocity = CVector();
		if(thetaDegL > theta1 * 0.8) mode = 1;
	}
	else if(mode ==1)
	{
		point[0].vPos.z = radius;//nʂɕt
		point[0].flagFixed = true;
		point[1].flagFixed = false;
		point[1].vVelocity.x = 2.0*speed * cos(direction);
		point[1].vVelocity.y = 2.0*speed * sin(direction);
		point[3].vVelocity.x = 2.0*speed * cos(direction);
		point[3].vVelocity.y = 2.0*speed * sin(direction);
		point[3].vForce0.z = 0.0;
		point[13].vVelocity.x = 2.3*speed * cos(direction);
		point[13].vVelocity.y = 2.3*speed * sin(direction);
		point[14].vVelocity = CVector();
		if(thetaDegL > theta1) mode = 2;
	}

	else if(mode == 2)
	{//EŒC/Eo
		point[1].vPos.z = radius;
		point[0].flagFixed = false;
		point[1].flagFixed = true;
		point[0].vVelocity.x = 2.0*speed * cos(direction);
		point[0].vVelocity.y = 2.0*speed * sin(direction);
		point[2].vVelocity.x = 2.0*speed * cos(direction);
		point[2].vVelocity.y = 2.0*speed * sin(direction);
		point[2].vForce0.z = 150.0 * mass;//G
		point[14].vVelocity.x = 2.3*speed * cos(direction);
		point[14].vVelocity.y = 2.3*speed * sin(direction);
		point[13].vVelocity = CVector();
		if(thetaDegR > theta1 * 0.8) mode = 3;
	}
	else if(mode == 3)
	{
		point[1].vPos.z = radius;//nʂɕt
		point[0].flagFixed = false;
		point[1].flagFixed = true;
		point[0].vVelocity.x = 2.0*speed * cos(direction);
		point[0].vVelocity.y = 2.0*speed * sin(direction);
		point[2].vVelocity.x = 2.0*speed * cos(direction);
		point[2].vVelocity.y = 2.0*speed * sin(direction);
		point[2].vForce0.z = 0.0;
		point[14].vVelocity.x = 2.3*speed * cos(direction);
		point[14].vVelocity.y = 2.3*speed * sin(direction);
		point[13].vVelocity = CVector();
		if(thetaDegR > theta1) mode = 0;
	}

	//isωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;
	if(alpha != 0.0)
	{
		//ol̕
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ_rad(alpha);
		//_̍W
		for(i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
	}
	direction0 = direction;

	calcSpringMass(timeStep);
}
