
#include "../../spring.h"

//int flagCollision = 1;//ՓˏL/
//int numPole = 0;
int numPoint = 2;
int actionType = 1;
int mode = 0;
double theta1 = 20.0;//OXp
double theta2 = -10.0;//Xp
int rootNo = 1;

class CSpringMass
{
public:
    CVector vPos;
	float speed;//isx
    //CVector vEuler;
	float mass;//_P̎
    float constK;
	float drctnK;
	float damping;
	float drag;
    float length0;  //sprinĝP莩R
    float radius ;//a
	float direction, direction0;//isix̌oxCdegj
double theta1;// = 20.0;//OXp
double theta2;// = -10.0;//Xp

    CVector vForce0;//O͂̏l
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];
	CRigid pole[2];

    //o֐
    CSpringMass();
    void draw(bool flagShadow);
    void create();
    void calcSpringMass(double dt);
	void action(double dt, double time);
private:
};
CSpringMass sm;
//---------------------------------------------------------------
CSpringMass::CSpringMass()
{
    vPos = CVector();
    length0 = 1.0;
	constK = 1000.0;
	drctnK = 100.0;
	mass = 1.0;
	drag = 0.0;
	damping = 0.0;
    radius = 0.03;
	theta1 = 20.0;
	theta2 = -10.0;
	vForce0 = CVector();
}
//-----------------------------------------------------------------
void CSpringMass::draw(bool flagShadow)
{
    int i;
    int r1, r2;
    CVector vEuler0, vEuler1;

    //΂ˎ_\
    //_
    for(i = 0; i < numPoint; i++) {
        point[i].color = CYAN;
        if(point[i].flagFixed == true){
            point[i].color= RED;
        }
        point[i].draw(flagShadow);
    }
    for(i = 0; i < numSpring; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }
}
//-----------------------------------------------------------------
void CSpringMass::create()
{

	if(actionType == 1)
	{
		numSpring = 1;

		//i̎_j
		point[0].vPos = CVector(0.0, 0.0, radius) + vPos;
//		point[0].vPos = CVector(0.0, length0 * sin(-theta1 * DEG_TO_RAD), radius) + vPos;
		//dSi̎_j
		point[1].vPos = CVector(0.0, 0.0, radius + length0) + vPos;
		//r(spring)
        spring[0].row1 = 0; spring[0].row2 = 1;
		//ol̕
		spring[0].vDir0 = CVector(0.0, 0.0, 1.0);

	}
	else if(actionType == 2)//2{r
	{
		numSpring = 4;
		numPoint = 5;
		float wid = 0.2 * length0;
		//R
		spring[0].length0 = spring[1].length0 = length0;
		spring[2].length0 = spring[3].length0 = wid;

		//
		point[0].vPos = CVector(-wid, 0.0, radius) + vPos;
		//E
		point[1].vPos = CVector( wid, 0.0, radius) + vPos;
		//
		point[2].vPos = CVector(-wid, 0.0, radius + length0) + vPos;
		//E
		point[3].vPos = CVector( wid, 0.0, radius + length0) + vPos;
		//rooti̎_j
		point[4].vPos = CVector( 0.0, 0.0, radius + length0) + vPos;
		//r(spring)
        spring[0].row1 = 0; spring[0].row2 = 2;
		//Er(spring)
        spring[1].row1 = 1; spring[1].row2 = 3;
		//(spring)
        spring[2].row1 = 2; spring[2].row2 = 4;
		//(spring)
        spring[3].row1 = 4; spring[3].row2 = 3;

		//ol̕
		spring[0].vDir0 = CVector(0.0, 0.0, 1.0);
		spring[1].vDir0 = CVector(0.0, 0.0, 1.0);
		spring[2].vDir0 = CVector(1.0, 0.0, 0.0);
		spring[3].vDir0 = CVector(1.0, 0.0, 0.0);
	}

    //_̃TCY,
    for(int i = 0; i < numPoint; i++){
        point[i].kind = SPHERE;
		point[i].vSize = CVector(2.0, 2.0, 2.0) * radius;
		point[i].mass = mass;
        point[i].vSize = CVector(2.0*radius, 2.0*radius, 2.0*radius);
    }
	//ol
    for(int i = 0; i < numSpring; i++){
		spring[i].radius = radius;
        spring[i].kind = S_CYLINDER;
	}

	//islyłȂƂ_̈ʒu/ol̕xNgς
	double alpha = direction - M_PI/2.0;
	if(alpha != 0.0)
	{
		for(int i = 0; i < numSpring; i++) spring[i].vDir0.rotZ(alpha * RAD_TO_DEG);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
	}

}

//-----------------------------------------------------------------------------
//1̃ol}Xf(hinge springlCRԂŉ^)
void CSpringMass::calcSpringMass(double dt)
{                                           
    int i, r1, r2;
    CVector vDir1, vDir2, vFF;
    CVector vRelativeVelocity;
    float dampingF;
    float len;
	double angle;
    CVector vNormal;

	//͂̑a
    //ݒl
    for(i = 0; i  < numPoint; i++)
        point[i].vForce = CVector(0.0, 0.0, -gravity * mass);

	//olɂ(\olj
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        len = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (len - spring[i].length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

	//oll
	for(i = 0; i < numSpring; i++)
	{
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;
        vNormal = vCross(spring[i].vDir0, vDir1);
		vDir2 = vCross(vNormal, vDir1);
		angle = getAngle(spring[i].vDir0, vDir1);
        vFF = drctnK * angle * vDir2 / spring[i].length;
        point[r2].vForce -= vFF ;
        point[r1].vForce += vFF;//vDir2Ɠ
	}

    //SRƏʏ
    for(i = 0; i < numPoint; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

		//ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
		point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
        point[i].vPos += point[i].vVelocity * dt;
    }
	vPos = point[0].vPos;
}

//----------------------------------------------------------------------------------
void CSpringMass::action(double timeStep, double time)
{
	int i;
	double theta, thetaDeg, dist;
	CVector vDirection = CVector(cos(direction), sin(direction), 0.0);//is̃xNg

	if(actionType == 1)//1{
	{
		//rootƑ̐itj
		dist = vDot(point[1].vPos - point[0].vPos, vDirection);
		//r̊px
		theta = atan2(dist, point[1].vPos.z - point[0].vPos.z); 
		thetaDeg = theta * RAD_TO_DEG;
		//rootɂ͈̐x^
		point[1].vVelocity.x = speed * cos(direction);
		point[1].vVelocity.y = speed * sin(direction);

		if(mode == 0)
		{//Œ
			point[0].flagFixed = true;
			if(thetaDeg > theta1) mode = 1;
		}
		else if(mode == 1)
		{//R
			point[0].flagFixed = false;
			if(thetaDeg < theta2) mode = 0;
		}
	}
	else if(actionType == 2 )
	{
		double thetaDegL, thetaDegR;
		
		//r̐itj
		dist = vDot(point[2].vPos - point[0].vPos, vDirection);
		//r̊px
		theta = atan2(dist, point[2].vPos.z - point[0].vPos.z); 
		thetaDegL = theta * RAD_TO_DEG;
		//Er̐itj
		dist = vDot(point[3].vPos - point[1].vPos, vDirection);
		//Er̊px
		theta = atan2(dist, point[3].vPos.z - point[1].vPos.z); 
		thetaDegR = theta * RAD_TO_DEG;
	
		for(i = 2; i < numPoint; i++)
		{
			point[i].vVelocity.x = speed * cos(direction);
			point[i].vVelocity.y = speed * sin(direction);
		}

		if(mode == 0)
		{//ŒCEo,
			point[0].flagFixed = true;
			point[1].flagFixed = false;
			point[1].vVelocity.x = 2.0*speed * cos(direction);
			point[1].vVelocity.y = 2.0*speed * sin(direction);
			if(thetaDegL > theta1) mode = 1;
		}
		else if(mode == 1)
		{//EŒCo
			point[0].flagFixed = false;
			point[1].flagFixed = true;
			point[0].vVelocity.x = 2.0*speed * cos(direction);
			point[0].vVelocity.y = 2.0*speed * sin(direction);
			if(thetaDegR > theta1) mode = 0;
		}
	}
	//isωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;
	if(alpha != 0.0)
	{
		//ol̕
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ_rad(alpha);
		//_̍W
		for(i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
		direction0 = direction;
	}

	calcSpringMass(timeStep);
}
