/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ol_f̎2
eNX`
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/
#define FILENAME_IN0 "../../bmp/ground1.bmp"
#define FILENAME_IN1 "../../bmp/grain1.bmp"
#define FILENAME_IN2 "../../bmp/leaf62.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigidVSM.h"
#include "spring_mass_tree3.h"
#include "setupTreeSM3.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void setTextureGround();
void setTextureGrain();
void setTextureLeaf();
void drawGround();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLuint texName[3];//eNX`ʖ

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

float heightFix0 = 2.0;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_TreeSM3");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteTextures(3, texName);
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.6, 0.6, 0.8, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 6.0;
	view.vCnt = CVector(0.0, 0.0, 1.5);
	view.theta = 10.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	muK = 0.2;
	restitut = 0.0;
	viscous = 0.05;
	timeRate = 1.0;

	glGenTextures(3, texName);//eNX`IuWFNg̖Ot
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN0);
	setTextureGround();
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN1);
	setTextureGrain();
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN2);
	setTextureLeaf();


	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	printf("}EX͎_Ɏgp \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;

	numTree = 2;
	for(int i = 0; i < numTree; i++)
	{
		sm[i] = CTreeSM();
		sm[i].damping = damping0;
		sm[i].drag = drag0;
		sm[i].mass = mass0;//KgPʁi_Pj
		sm[i].constK0 = constK0;//olPiŜ1/numSpring)
		sm[i].drctnK0 = drctnK0;
		sm[i].lengthTrunk0 = lengthTrunk0;
		sm[i].radiusTrunk0 = radiusTrunk0;
		sm[i].lengthBranch0 = lengthTrunk0 * 0.5;
		sm[i].radiusBranch0 = radiusTrunk0 * 0.4;
		sm[i].numTrunk = numTrunk0;
		sm[i].alpha = alpha0 * DEG_TO_RAD;
		sm[i].beta = beta0 * DEG_TO_RAD;
		sm[i].rate = rate0;
		sm[i].variation = variation0;

		sm[0].vPos0 = sm[0].vPos = CVector(0.0, -1.5, 0.0);//n_ʒuŜ̈ʒu\i{j
		sm[1].vPos0 = sm[1].vPos = CVector(0.0,  1.5, 0.0);//n_ʒuŜ̈ʒu\i{j

		sm[i].create();
		sm[i].point[0].flagFixed = true;
	}

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}
void setTextureGround()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureGrain()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureLeaf()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[2]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, texName[0]);
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(GL_TEXTURE_2D, texName[1]);
	glActiveTexture(GL_TEXTURE2);
	glBindTexture(GL_TEXTURE_2D, texName[2]);
	GLint imageLoc;
	glUseProgram(shaderProg);
	//n
	if(flagFloor)
	{
		imageLoc = glGetUniformLocation(shaderProg, "image");
		glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
		GLint selLoc = glGetUniformLocation(shaderProg, "select");
		glUniform1i(selLoc, 1);
		drawGround();
	}
 	//
	sm[0].draw(false, imageLoc);
	sm[1].draw(false, imageLoc);

	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	glUseProgram(0);

	timeStep = timeRate * dt;
	windVelY = windVelY0;
	windFreq = windFreq0;
	windAmp = windAmp0;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 10.0 * timeStep0 || timeStep < timeStep0 / 10.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		double tt = timeStep / 50.0;
		for(int i = 0; i < numTree; i++)
		{
			for(int j = 0; j < 50; j++)
			{
				sm[i].motion(tt, elapseTime2);
			}
		}

		if(flagOneStep) flagFreeze = true;
		elapseTime2 += timeStep;
	}

	if(flagShadow) drawShadow();     //e(setupSM1.h)
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5);   //[hԂ̍W(setupSM1.h)
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	if(flagTrack)
	{
		view.vCnt.x = sm[0].vPos.x;
		view.vCnt.y = sm[0].vPos.y;
		setCamera();
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}

void drawGround()
{
	float diffuseG[] = {0.5f, 0.7f, 0.6f, 1.0f};
	float ambientG[] = {0.2f, 0.3f, 0.1f, 1.0f};
	float specularG[] = {0.1f, 0.1f, 0.1f, 1.0f};
	float highlightG = 5.0;
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuseG);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambientG);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specularG);
	glMaterialf(GL_FRONT,GL_SHININESS,highlightG);
		
	drawTexPlate(20.0, 10, 10);
}
