
//1ol_fŎ؂\
//tN^3،`
//ol_\
#include "springTree3.h"

int numPoint;
int numPointG, numSpringG;//̍ŏ̎_ԍƃolԍ
int numPointL, numSpringL;//[̗t̍ŏ̎_ԍƃolԍ
float windVelY, windFreq, windAmp;

class CTreeSM
{
public:
    CVector vPos, vPos0;//̈ʒu
    CVector vForce0;//O͂̏l
	//ol-_
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];
	CRigid leaf[MAX_SPRING];
	float constK[MAX_SPRING];
	float drctnK[MAX_SPRING + 1];
	float mass;//_P̎
	float radius;//_̔a
    float constK0;
	float drctnK0;
	float damping, drag;
	float variation;//ϓ
	//itrunk)
	int numTrunk;
	float lengthTrunk0;//̍ŉ[̒
    float radiusTrunk0 ;//̍ŉ[̔a
	float rate;//
	//}
	int numBranch0;//1̊_ŕ򂷂}
	int numBranch; //}番}
	int numGeneration;//}̐㐔
	float lengthBranch0;
	float radiusBranch0;
	float alpha;//p
	float beta; //ʂƂ̊px

    //o֐
    CTreeSM();
    void draw(bool flagShadow, int imaeLoc);
	void drawLeaf(bool flagShadow);
    void create();//initialize();
    void motion(double dt, double t);
private:
};
CTreeSM sm[2];
//---------------------------------------------------------------
CTreeSM::CTreeSM()
{
    vPos = vPos0 = CVector();//̈ʒu
	constK0 = 1000.0;
	drctnK0 = 1000.0;
	mass = 1.0;
	radius = 0.1;
	drag = 0.0;
	damping = 0.0;
	variation = 0.0;
	//
	numTrunk = 3;
	lengthTrunk0 = 1.0;
    radiusTrunk0 = 0.1;
	rate = 0.85;
	//}iCjVG[^j
	numBranch0 = 4;//e}
	numBranch = 3;//3Ɍiq}j
	numGeneration = 2;
	lengthBranch0 = 0.5;
	radiusBranch0  = 0.05;

	vForce0 = CVector();
}
//-----------------------------------------------------------------
void CTreeSM::draw(bool flagShadow, int imageLoc)
{
    int i;
    int r1, r2;
	static float shadowDiffuse[] = {0.2f,0.2f,0.2f,0.3f};//e̊gU
	static float shadowSpecular[] = {0.0f,0.0f,0.0f,1.0f};//e̋ʌ

	//ƔˌR,G,BWŎw肳Ă
	static float diffuse[]  = {0.9, 0.9, 0.9, 1.0};
	static float ambient[]  = {0.7, 0.7, 0.7, 1.0};
	static float specular[] = {1.0, 1.0, 1.0, 1.0};

	if(flagShadow == false){
		glMaterialfv(GL_FRONT,GL_DIFFUSE, diffuse);
		glMaterialfv(GL_FRONT,GL_AMBIENT, ambient);
		glMaterialfv(GL_FRONT,GL_SPECULAR, specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 5.0);
	}
	else{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
	}

	glUniform1i(imageLoc, 1);//GL_TEXTURE1Kp
    for(i = 0; i < numSpring; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }

	glUniform1i(imageLoc, 2);//GL_TEXTURE2Kp
	drawLeaf(flagShadow);

}
//------------------------------------------------------------------
void CTreeSM::drawLeaf(bool flagShadow)
{
	static float shadowDiffuse[] = {0.2f,0.2f,0.2f,0.05f};//e̊gU
	static float shadowSpecular[] = {0.0f,0.0f,0.0f,1.0f};//e̋ʌ

	//ƔˌR,G,BWŎw肳Ă
	static float diffuse[]  = {0.8, 1.0, 0.3, 1.0};
	static float specular[] = {0.2, 0.2, 0.2, 1.0};

	if(flagShadow == false){
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR, specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 5.0);
	}
	else{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
	}

	for(int i = numTrunk+1; i < numPoint-1; i++)
	{
		glPushMatrix();
		glTranslatef(point[i].vPos.x, point[i].vPos.y, point[i].vPos.z + 0.01); 
		glRotatef(point[i].vEuler.z, 0.0, 0.0, 1.0);
		glRotatef(point[i].vEuler.y, 0.0, 1.0, 0.0);
		glRotatef(point[i].vEuler.x, 1.0, 0.0, 0.0);
		glScalef(point[i].vSize.x, point[i].vSize.y, point[i].vSize.z); 
		glTranslatef(0.5, 0.0, 0.05); 
		drawTexPlate(1.0, 1, 1);//xyʂ̔Ƀ_O
		glPopMatrix();
	}
}
//-----------------------------------------------------------------
void CTreeSM::create()
{
    int i, j, k, m, n0, n1;

	float var = variation / 2.0;//ϓ
	numPoint = 0;
	numSpring = 0;
	float len = lengthTrunk0;
	float rad = radiusTrunk0;
 	//
    for(i = 0; i <= numTrunk; i++)
	{
        point[i].vSize = CVector(2.0*rad, 2.0*rad, 2.0*rad);
		point[i].vPos0.x = point[i].vPos.x = vPos.x + getRandom(-var, var) * 0.1;
		point[i].vPos0.y = point[i].vPos.y = vPos.y + getRandom(-var, var) * 0.1;
		if(i == 0) 
		{
			point[i].vPos0.z =  point[i].vPos.z = 0.0;
		}
		else
			point[i].vPos0.z =  point[i].vPos.z = point[i-1].vPos.z + len * (1.0 + getRandom(-var, var));
       
		numPoint ++;
		if(i >= 1){
			len *= rate;
			rad *= rate;
		}
    }
	//olɐڑ鎿_ԍƃol̕
	rad = radiusTrunk0 * 0.8;
	float cck = constK0;
	float hhk = drctnK0;
    for(i = 0; i < numTrunk; i++)
    {
        spring[i].radius = rad;
        spring[i].row1 = i;
        spring[i].row2 = i+1;
		spring[i].length0 = vDist(point[i].vPos0, point[i+1].vPos0);
		spring[i].vDir0 = point[i].vPos0 >> point[i+1].vPos0;
		constK[i] = cck;
		drctnK[i] = hhk * 5.0;
		rad *= rate;
		cck *= rate * 0.5;
		hhk *= rate * 0.5;
		numSpring ++;
	}
	//e}
	len = lengthBranch0;
	rad = radiusBranch0;
	float gamma = 2.0 * M_PI / (float)numBranch0;//tʒuix̌oxj
    for(i = 1; i <= numTrunk; i++)
	{
		for(j = 0; j < numBranch0; j++)
		{
			point[numPoint].vSize = CVector(2.0*rad, 2.0*rad, 2.0*rad);
			point[numPoint].vPos0.x = point[numPoint].vPos.x = point[i].vPos.x + len * cos(beta) * cos(gamma *(double)j) * (1.0 + getRandom(-var, var));
			point[numPoint].vPos0.y = point[numPoint].vPos.y = point[i].vPos.y + len * cos(beta) * sin(gamma *(double)j) * (1.0 + getRandom(-var, var));
			point[numPoint].vPos0.z = point[numPoint].vPos.z = point[i].vPos.z + len * sin(beta) * (1.0 + getRandom(-var, var));
			numPoint ++;
		}
		len *= rate;
		rad *= rate;
    }
    //olɐڑ鎿_ԍƕ
	rad = radiusBranch0 * 0.8;
	cck = constK0 * 0.5;
	hhk = drctnK0 * 0.5;
    for(i = 1; i <= numTrunk; i++)
    {
		for(j = 0; j < numBranch0; j++)
		{
			n0 = numTrunk+1 + (i-1)*numBranch0 + j;//e}_ԍ
			spring[numSpring].radius = rad;
			spring[numSpring].row1 = i;
			spring[numSpring].row2 = n0;
			spring[numSpring].length0 = vDist(point[i].vPos0, point[n0].vPos0);
			spring[numSpring].vDir0 = point[i].vPos0 >> point[n0].vPos0;
			constK[numSpring] = cck;
			drctnK[numSpring] = hhk;
			numSpring ++;
		}
		rad *= rate;
		cck *= rate * 0.5;
		hhk *= rate * 0.5;
	}

	//q}
	len = lengthBranch0 * rate;
	rad = radiusBranch0 * rate;
	beta *= rate;//M_PI / 10.0;//ʂƂ̊px
	gamma = 2.0 * M_PI / (float)numBranch0;//tʒuix̌oxj
    for(i = 1; i <= numTrunk; i++)
	{
		for(j = 0; j < numBranch0; j++)
		{
			for(k = 0; k < numBranch; k++)
			{
				n0 = numTrunk+1 + (i-1)*numBranch0 + j;//e}_ԍ
				point[numPoint].vSize = CVector(2.0*rad, 2.0*rad, 2.0*rad);
				point[numPoint].vPos0.x = point[numPoint].vPos.x = point[n0].vPos0.x + len * cos(beta) * cos(gamma *(double)j + alpha * ((double)k -1.0)) * (1.0 + getRandom(-var, var));
				point[numPoint].vPos0.y = point[numPoint].vPos.y = point[n0].vPos0.y + len * cos(beta) * sin(gamma *(double)j + alpha * ((double)k -1.0)) * (1.0 + getRandom(-var, var));
				point[numPoint].vPos0.z = point[numPoint].vPos.z = point[n0].vPos0.z + len * sin(beta) * (1.0 + getRandom(-var, var));
				numPoint ++;
			}
		}
		len *= rate;
		rad *= rate;
    }
    //olɐڑ鎿_ԍƕ
	rad = radiusBranch0 * rate;
	cck = constK0 * 0.25;
	hhk = drctnK0 * 0.1;
	n1 =  numTrunk + 1 + numTrunk * numBranch0;//q}̍ŏ̎_ԍ
    for(i = 1; i <= numTrunk; i++)
    {
		for(j = 0; j < numBranch0; j++)//e}ԍ
		{
			for(k = 0; k < numBranch; k++)//q}ԍ
			{
				n0 = numTrunk + 1 + (i-1)*numBranch0 + j;//e}_ԍ
				spring[numSpring].radius = rad;
				spring[numSpring].row1 = n0;
				spring[numSpring].row2 = n1;
				spring[numSpring].length0 = vDist(point[n0].vPos0, point[n1].vPos0);
				spring[numSpring].vDir0 = point[n0].vPos0 >> point[n1].vPos0;
				constK[numSpring] = cck;
				drctnK[numSpring] = hhk;
				numSpring ++;
				n1++;
			}
		}
		rad *= rate;
		cck *= rate * 0.5;
		hhk *= rate * 0.5;
	}
	numPointG = numPoint;
	numSpringG = numSpring;
	//}
	len = lengthBranch0 * rate * rate;
	rad = radiusBranch0 * rate * rate;
	beta *= rate;//M_PI / 15.0;//ʂƂ̊px
	gamma = 2.0 * M_PI / (float)numBranch0;//tʒuix̌oxj
	//alpha = M_PI / 6.0;//}̊g
	n0 = numTrunk + 1 + numTrunk*numBranch0;//ŏ̎q}_ԍ
    for(i = 1; i <= numTrunk; i++)
	{
		for(j = 0; j < numBranch0; j++)
		{
			for(k = 0; k < numBranch; k++)
			{
				for(m = 0; m < numBranch; m++)
				{
					point[numPoint].vSize = CVector(2.0*rad, 2.0*rad, 2.0*rad);
					point[numPoint].vPos0.x = point[numPoint].vPos.x = point[n0].vPos0.x + len * cos(beta) * cos(gamma *(double)j + alpha * ((double)(k+m) -2.0) ) * (1.0 + getRandom(-var, var));
					point[numPoint].vPos0.y = point[numPoint].vPos.y = point[n0].vPos0.y + len * cos(beta) * sin(gamma *(double)j + alpha * ((double)(k+m) -2.0)) * (1.0 + getRandom(-var, var));
					point[numPoint].vPos0.z = point[numPoint].vPos.z = point[n0].vPos0.z + len * sin(beta) * (1.0 + getRandom(-var, var));
					numPoint ++;
				}
				n0++;
			}
		}
		len *= rate;
		rad *= rate;
    }
	
    //olɐڑ鎿_ԍƕ
	rad = radiusBranch0 * rate * rate;
	cck = constK0 * 0.1;
	hhk = drctnK0 * 0.001;
	n0 = numTrunk + 1 + numTrunk*numBranch0;//ŏ̎q}_ԍ
	n1 =  numTrunk + 1 + numTrunk * numBranch0 * (1 + numBranch);//ŏ̑}_ԍ
    for(i = 1; i <= numTrunk; i++)
    {
		for(j = 0; j < numBranch0; j++)//e}ԍ
		{
			for(k = 0; k < numBranch; k++)//q}ԍ
			{
				for(m = 0; m < numBranch; m++)
				{
					spring[numSpring].radius = rad;
					spring[numSpring].row1 = n0;
					spring[numSpring].row2 = n1;
					spring[numSpring].length0 = vDist(point[n0].vPos0, point[n1].vPos0);
					spring[numSpring].vDir0 = point[n0].vPos0 >> point[n1].vPos0;
					constK[numSpring] = cck;
					drctnK[numSpring] = hhk;
					numSpring ++;
					n1++;
				}
				n0++;
			}
		}
		rad *= rate;
		cck *= rate;
		hhk *= rate;
	}

	numPointL = numPoint;//ŏ̗t̎_ԍ
	numSpringL = numSpring;//ŏ̗t̃olԍ

	//}̐[̎_t̎_Ƃ
	len = 0.1;
	rad = radiusBranch0 * rate * rate;
	for(i = numPointG; i < numPointL; i++)
	{
		point[numPoint].vSize = CVector(2.0*rad, 2.0*rad, 2.0*rad) ;
		point[numPoint].vPos0.x = point[numPoint].vPos.x = point[i].vPos0.x + len * spring[i - 1].vDir0.x * (1.0 + getRandom(-var, var));
		point[numPoint].vPos0.y = point[numPoint].vPos.y = point[i].vPos0.y + len * spring[i - 1].vDir0.y * (1.0 + getRandom(-var, var));
		point[numPoint].vPos0.z = point[numPoint].vPos.z = point[i].vPos0.z + len * spring[i - 1].vDir0.z * (1.0 + getRandom(-var, var));
		numPoint ++;
	}

	n0 = numPointG;
	n1 = numPointL;
	for(i = numSpringG; i < numSpringL; i++)
	{
		spring[numSpring].radius = rad;
		spring[numSpring].row1 = n0;
		spring[numSpring].row2 = n1;
		spring[numSpring].length0 = vDist(point[n0].vPos0, point[n1].vPos0);
		spring[numSpring].vDir0 = point[n0].vPos0 >> point[n1].vPos0;
		constK[numSpring] = cck;
		drctnK[numSpring] = hhk * 0.05;
		numSpring++;
		n0++;
		n1++;
	}

	//t(ȊO̎_tƂj
    for(i = numTrunk+1; i < numPoint-1; i++)
	{
		point[i].vSize = CVector(0.02, 0.02, 1.0)  * (1.0 + getRandom(-var, var)) ;
		//t̎p͗t_xĂol̕ɍ킹
		point[i].vEuler = getEulerX(spring[i-1].vDir0);
	}
}

//-----------------------------------------------------------------------------
void CTreeSM::motion(double dt, double t)
{                                           
    int i, r1, r2;
    CVector vDir1, vDir2, vFF;
    CVector vRelativeVelocity;
    double dampingF;
    double angle;
    CVector vNormal;

	//͂̑a
    //ݒliȂǂ̊Ój
    for(i = 0; i  < numPoint; i++)
	{
		float wind = windAmp * sin(2.0 * M_PI * windFreq * (t -  point[i].vPos.y / windVelY));
		vForce0.x = windVelY * wind ;
		vForce0.y = windAmp * windVelY * (1.0 + wind);
		vForce0.z =  windVelY * wind * 0.1;
		point[i].vForce = vForce0 + CVector(0.0, 0.0, -gravity * mass);
	}

	//olɂ
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK[i] * (spring[i].length - spring[i].length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

	//oll
	for(i = 0; i < numSpring; i++)
	{
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;
        vNormal = vCross(spring[i].vDir0, vDir1);
		vDir2 = vCross(vNormal, vDir1);
		angle = getAngle(spring[i].vDir0, vDir1);
        vFF = drctnK[i] * angle * vDir2 / spring[i].length;
        point[r2].vForce -= vFF ;
        point[r1].vForce += vFF;//vDir2Ɠ
	}

    //SRƏʏ
    for(i = 0; i < numPoint; i++)
    {
        if(point[i].flagFixed) continue; //Œ

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

        if( point[i].vPos.z <= radius){
        }
        //ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
        point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
		point[i].vPos += point[i].vVelocity * dt;
			
		//t̕
		point[i].vEuler = getEulerX(point[spring[i-1].row1].vPos, point[spring[i-1].row2].vPos);
    }

	vPos = point[0].vPos;

	for(i = 1; i < numPoint; i++){
		point[i].vPos0 += (point[0].vPos - point[0].vPos0);
	}
	
	point[0].vPos0 = vPos;
	vPos0 = vPos;

}

