const float pi = 3.14159265;
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerWave;
uniform int texWidth;//_~[܂XSiq
uniform int nDummy;
uniform float size0;//ۂ1ӂ̒(_~[܂܂j
uniform int nSource;
uniform float sourceY;
uniform float interval;
uniform float amp;
uniform float freq;
uniform float drag0;
uniform float waveVel;
uniform int mode;
//uniform int boundary;
uniform float dt;
uniform float time;

varying vec2 texPos;
int texHeight = texWidth;

float makeWave(vec2 pos, float v0);

void main(void)
{
	int nSlice0 = texWidth - 2 * nDummy - 1;//L̈̕iiqj
	
	vec4 wave = texture2DRect(samplerWave, texPos);//ړ_
	//̈̒S_ɕύX

	vec2 pos = texPos.xy - vec2(float((texWidth)/2), float((texHeight)/2));
	//TCYϊ
	pos *= size0 / float(nSlice0);//texWidth - 2 * nDummy);
	wave.r = makeWave(pos, wave.r);//g̔g쐬(xj

	float d = size0 / float(nSlice0);//iqԊu	
	float dd = d * d;
	float drag = drag0;
	int nm = nDummy;          //˂̂Ƃ̗L̈拫Eԍ	
	int np = nSlice0 + nDummy;//˂̂Ƃ̗L̈拫Eԍ
	//int im, ip, jm, jp;
	//float zmi, zpi, zmj, zpj;
	//float coef;

    int i = int(texPos.x);
    int j = int(texPos.y);
    //ˏI[
	float dragMax = 5.0;
	if(j < nm) drag = drag0 + dragMax * float(nm - j) / float(nDummy);
	if(j > np) drag = drag0 + dragMax * float(j - np) / float(nDummy);
	if(i < nm) drag = drag0 + dragMax * float(nm - i) / float(nDummy);
	if(i > np) drag = drag0 + dragMax * float(i - np) / float(nDummy);

	////EW߂
	vec4 waveA, waveB, waveC, waveD;
	float cc, cA, cB, cC, cD;
	waveA = texture2DRect(samplerWave, texPos + vec2(-1.0, 0.0));
	waveB = texture2DRect(samplerWave, texPos + vec2( 1.0, 0.0));
	waveC = texture2DRect(samplerWave, texPos + vec2( 0.0,-1.0));
	waveD = texture2DRect(samplerWave, texPos + vec2( 0.0, 1.0));
	if(waveA.a == 1.0) cA = 0.0; else cA = 1.0;
	if(waveB.a == 1.0) cB = 0.0; else cB = 1.0;
	if(waveC.a == 1.0) cC = 0.0; else cC = 1.0;
	if(waveD.a == 1.0) cD = 0.0; else cD = 1.0;
	
	if(waveA.a == 1.0 || waveB.a == 1.0 || waveC.a == 1.0 || waveD.a == 1.0) cc = 3.0;
	else cc = 4.0;

	//IC[@
	float accel;
	if(wave.a == 0.0)//ړ_
		accel = (waveVel * waveVel) * (cA*waveA.g + cB*waveB.g + cC*waveC.g + cD*waveD.g - cc * wave.g) / dd;
	else accel = 0.0;//n/Q

	//SR
	accel -= drag * wave.r;
	//x̍XV
	wave.r += accel * dt;

	gl_FragColor = wave;
}

//--------------------------------------------------------
float makeWave(vec2 pos, float v0)
{
	int k;
	vec2 source;//g̈ʒu

	float value = v0;
	float period = 1.0 / freq;
	for(k = 0; k < nSource; k++)
	{
		source.x = floor(interval * (-0.5 * float(nSource-1) + float(k)));
		source.y = sourceY;

		if(pos.x == source.x && pos.y == source.y)
		{
			if(mode == 0)//SINGLE
			{
				if(time < period) value = amp * freq *sin(2.0 * pi * freq * time);
			}
			else  value = amp * freq * sin(2.0 * pi * freq * time);
		}
	}
	return value;
}
