/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

g2
GPGPU(lvZGPUŎsj
V̂ꍇ(́CX΂l)
V̂ɃeNX`\
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../rigidWave.h"
#include "../../setupWave.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void rendering();
void setTextureWave();
void setFramebufferVel();
void setFramebufferWave();
void drawNumberingPoints();
void renewVelocity(float dt);
void renewPosition(float dt);
void decideRegion();
float regionFlag(float x, float y);
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//͗pf[^̃TCY
int texWidth, texHeight;//Siq

//͗pf[^z
float *wave;
GLuint texID[2];//texture object
GLuint fb[1];//frame buffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGBA;
GLenum type = GL_FLOAT;
//VF[_vO
GLuint shader_prog1, shader_prog2, shader_prog3, shader_prog4;

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;
int nDummy;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("GP_WaveEquation2");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ĕ`
	glutIdleFunc(idle);
	//ݒ
	glewInit();//framebuffer𗘗pƂɕKv
	init();
	initGlsl(&shader_prog1, "simulation.vert", "velocity.frag");
	initGlsl(&shader_prog2, "simulation.vert", "position.frag");
	initGlsl(&shader_prog3, "rendering.vert", "rendering.frag");
	initGlsl(&shader_prog4, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
 	free(wave);
	glDeleteTextures(2, texID);
	glDeleteFramebuffersEXT(1, fb);
	glDeleteProgram(shader_prog1);
	glDeleteProgram(shader_prog2);
	glDeleteProgram(shader_prog3);
	glDeleteProgram(shader_prog4);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);
	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 60.0;
	view.vCnt = CVector(0.0, 0.0, 0.0);
	view.theta = 30.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	glGenTextures(1, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(1, fb);//t[obt@IuWFNg̐

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;

	nDummy = 30;//_~[iq(Б)

	//eNZTCY
	texWidth  = nSlice0 + 2 * nDummy + 1;//WeNX`̉TCY
	texHeight = texWidth;                //WeNX`̏cTCY
	
	//ʔz̐錾
	wave = (float*)malloc(4 * texWidth * texHeight * sizeof(float));

	//initialize
	int i, j, k;
	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			//g̍Ƃx
			wave[k * 4 + 0] = 0.0;//ĝx
			wave[k * 4 + 1] = 0.0;//gl
			wave[k * 4 + 2] = 0.0;
			wave[k * 4 + 3] = 0.0;//̈tO	
		}

	//V
	numRigid = 1;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();

	rigid[0].kind = (Kind)kind0;//CUBE;//CYLINDER;//
	rigid[0].flagFixed = false;
	rigid[0].color = RED;
	rigid[0].vPos = CVector(0.0, 0.0, height0);
	rigid[0].vSize = CVector(sizeX0, sizeY0, sizeZ0);
	rigid[0].vVelocity = CVector(0.0, 0.0, 0.0);
	
	rigid[0].vEuler = CVector(0.0, 0.0, 0.0);
	rigid[0].q = getQFromEulerZYX(rigid[0].vEuler) * rigid[0].q;//Ԃɂ]
	rigid[0].specificG = specificG0;
	rigid[0].select = 1;//eNX`
	rigid[0].ready();
	decideRegion();

	setTextureWave();
	setFramebufferWave();
	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTextureWave()
{
	glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, wave);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setFramebufferWave()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTexture()
{
	glBindTexture(target, texID[1]);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glBindTexture(target, 0);
}


void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		//step1:glx̍XV
		renewVelocity(timeStep);

		//step2:gl̍XV
		renewPosition(timeStep);

		for(int k = 0; k < numRigid; k++) 
		{
			if(rigid[k].flagFixed == false) rigid[k].action(timeStep);
		}
		if(flagOneStep) flagFreeze = true;
		elapseTime2 += timeStep;
	}

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	resize(win_width, win_height);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	rendering();//g`

	//QCE, V
	GLint imageLoc = glGetUniformLocation(shader_prog4, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	glUseProgram(shader_prog4);
	GLint wireLoc = glGetUniformLocation(shader_prog4, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shader_prog4, "select");
	glUniform1i(selLoc,1);
	for(int k = 0; k < numRigid; k++) rigid[k].draw(false);
	glUseProgram(0);

	if(flagCoordShow) drawWorldCoordinates(5.0);//[hԂ̍W
	
	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", (float)elapseTime2, 400, 30);
	}
	//obt@̐؂ւ
	glutSwapBuffers();	
}


void renewVelocity(float dt)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//wave
	//VF[_vOL
	glUseProgram(shader_prog1);
	GLint samplerWaveLoc = glGetUniformLocation(shader_prog1, "samplerWave");
	glUniform1i(samplerWaveLoc, 0);//GL_TEXTURE0Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog1, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint dummyLoc = glGetUniformLocation(shader_prog1, "nDummy");
	glUniform1i(dummyLoc, nDummy);
	GLint sizeLoc = glGetUniformLocation(shader_prog1, "size0");
	glUniform1f(sizeLoc, size0);
	GLint sourceYLoc = glGetUniformLocation(shader_prog1, "sourceY");
	glUniform1f(sourceYLoc, sourceY0);
	GLint sourceLoc = glGetUniformLocation(shader_prog1, "nSource");
	glUniform1i(sourceLoc, nSource0);
	GLint intervalLoc = glGetUniformLocation(shader_prog1, "interval");
	glUniform1f(intervalLoc, interval0);
	GLint ampLoc = glGetUniformLocation(shader_prog1, "amp");
	glUniform1f(ampLoc, amp0);
	GLint freqLoc = glGetUniformLocation(shader_prog1, "freq");
	glUniform1f(freqLoc, freq0);
	GLint waveVelLoc = glGetUniformLocation(shader_prog1, "waveVel");
	glUniform1f(waveVelLoc, waveVel0);
	GLint dragLoc = glGetUniformLocation(shader_prog1, "drag0");
	glUniform1f(dragLoc, drag0);
	GLint modeLoc = glGetUniformLocation(shader_prog1, "mode");
	glUniform1i(modeLoc, mode);
	GLint dtLoc = glGetUniformLocation(shader_prog1, "dt");
	glUniform1f(dtLoc, timeStep);
	GLint timeLoc = glGetUniformLocation(shader_prog1, "time");
	glUniform1f(timeLoc, elapseTime2);

	GLint coefBLoc = glGetUniformLocation(shader_prog1, "coefB");
	glUniform1f(coefBLoc, coefB0);
	GLint coefDownLoc = glGetUniformLocation(shader_prog1, "coefDown");
	glUniform1f(coefDownLoc, coefDown0);
	GLint posObjLoc = glGetUniformLocation(shader_prog1, "posObj");
	float pos[] ={ rigid[0].vPos.x, rigid[0].vPos.y, rigid[0].vPos.z};
	glUniform3fv(posObjLoc, 1, pos);
	GLint sizeObjLoc = glGetUniformLocation(shader_prog1, "sizeObj");
	float size[] = { rigid[0].vSize.x, rigid[0].vSize.y, rigid[0].vSize.z};
	glUniform3fv(sizeObjLoc, 1, size);
	GLint velObjLoc = glGetUniformLocation(shader_prog1, "velObj");
	float vel[] = { rigid[0].vVelocity.x, rigid[0].vVelocity.y, rigid[0].vVelocity.z};
	glUniform3fv(velObjLoc, 1, vel);
	//l͗p̃eNX`\tIuWFNg
	drawNumberingPoints();
	// VF[_vỎ 
	glUseProgram(0);

	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );


}

void renewPosition(float dt)
{
	//framebuffer object1L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fb[0] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//wave[]
	//VF[_vOL
	glUseProgram(shader_prog2);
	GLint samplerWaveLoc = glGetUniformLocation(shader_prog2, "samplerWave");
	glUniform1i(samplerWaveLoc, 0);//GL_TEXTURE0Kp

	GLint texWidthLoc = glGetUniformLocation(shader_prog2, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint dtLoc = glGetUniformLocation(shader_prog2, "dt");
	glUniform1f(dtLoc, dt);

	drawNumberingPoints();//l͗p̃eNX`iʁj\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, wave);
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	for(int m = 0; m < numRigid; m++)
	{
		if(rigid[m].flagFixed == false)
		{
			//̂̒SWɑ΂iqԍ
			float len = size0 + 2.0*(size0/(float)nSlice0)*(float)nDummy;
			int i = (int)((float)(texWidth-1)*(rigid[m].vPos.x) / len) + (texWidth-1) / 2;
			int j = (int)((float)(texHeight-1)*(rigid[m].vPos.y) / len) + (texHeight-1) / 2;
			if(i < 0 || j < 0 || i > texWidth -1 || j > texHeight-1) return;
			int k = i + j * texWidth;
			rigid[m].waveH = wave[k * 4 + 1];//̈ʒu̔g̍
			//@xNg
			float d = size0 / (float)nSlice0;
			k = i+1 + j * texWidth;
			CVector A = CVector(d, 0.0, wave[k * 4 + 1] - rigid[m].waveH);
			k = i + (j+1) * texWidth;
			CVector B = CVector(0.0, d, wave[k * 4 + 1] - rigid[m].waveH);
			rigid[m].vNormal = vCross(A, B);
			rigid[m].vNormal.norm();//ʂ̖@xNg
			for(int n = 0; n < rigid[m].numRepre; n++)
			{//\_ɑ΂g̍C@xNg߂
				//WorldWɕϊ
				for(int i = 0; i < rigid[m].numRepre; i++) 
					rigid[m].vRepre[i] = qvRotate(rigid[m].q, rigid[m].vRepre0[i]) + rigid[m].vPos;

				int i = (int)((float)(texWidth-1)*(rigid[m].vRepre[n].x) / len) + (texWidth-1) / 2;
				int j = (int)((float)(texHeight-1)*(rigid[m].vRepre[n].y) / len) + (texHeight-1) / 2;
				if(i < 0 || j < 0 || i > texWidth -1 || j > texHeight-1) return;
				int k = i + j * texWidth;
				rigid[m].waveRepreH[n] = wave[k * 4 + 1];//̈ʒu̔g̍
				//@xNg
				k = i+1 + j * texWidth;
				A = CVector(d, 0.0, wave[k * 4 + 1] - rigid[m].waveRepreH[n]);
				k = i + (j+1) * texWidth;
				B = CVector(0.0, d, wave[k * 4 + 1] - rigid[m].waveRepreH[n]);
				rigid[m].vNormalRepre[n] = vCross(A, B);
				rigid[m].vNormalRepre[n].norm();//ʂ̖@xNg
			}
		}
	}
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_W2iq_ԍ
	glEnd();
}

void rendering()
{
	glUseProgram(shader_prog3);

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//wave

	GLint samplerWaveLoc = glGetUniformLocation(shader_prog3, "samplerWave");
	glUniform1i(samplerWaveLoc, 0);//GL_TEXTURE1Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog3, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint dummyLoc = glGetUniformLocation(shader_prog3, "nDummy");
	glUniform1i(dummyLoc, nDummy);

	GLint sliceLoc = glGetUniformLocation(shader_prog3, "nSlice0");
	glUniform1i(sliceLoc, nSlice0);
	GLint sizeLoc = glGetUniformLocation(shader_prog3, "size0");
	glUniform1f(sizeLoc, size0);

	static float diffuse[] = { 0.4f, 0.6f, 0.9f, 1.0f};
	static float ambient[] = { 0.1f, 0.2f, 0.3f, 1.0f};
	static float specular[]= { 1.0f, 1.0f, 1.0f, 1.0f};

	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,10.0);
	if(flagWireframe == 0)
		drawGridPlate((float)nSlice0, (float)nSlice0, nSlice0, nSlice0);
	else
		drawGridLines((float)nSlice0, (float)nSlice0, nSlice0, nSlice0);

	glUseProgram(0);

}

void decideRegion()
{
	int i, j, k;
	float x, y;
	float gridWidth = size0 / (float)nSlice0;

	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			//iq_̍W
			x = (float)(i - texWidth / 2) * gridWidth;
			y = (float)(j - texHeight / 2) * gridWidth;
			wave[k * 4 + 3] = regionFlag(x, y);
		}
}

float regionFlag(float x, float y)
{//Ώې}`̊{pŔ
	CVector vPoint0 = CVector(x, y, 0.0);
	CVector vPoint;

	for(int k = 0; k < numRigid; k++)
	{
		//Ώې}`̒Sɕsړ̉]
		vPoint = vPoint0 - rigid[k].vPos;
		vPoint.rotZ(-rigid[k].vEuler.z);
		if(rigid[k].kind == CUBE)
		{
			if( vPoint.x >= - rigid[k].vSize.x / 4.0 && vPoint.x <= rigid[k].vSize.x / 2.0
			 && vPoint.y >= - rigid[k].vSize.y / 2.0 && vPoint.y <= rigid[k].vSize.y / 2.0)
			{
				if(rigid[k].flagFixed == true) return 1.0;//ŒQ
				else                           return 2.0;//V
			}
		}
		else if(rigid[k].kind == SPHERE || rigid[k].kind == CYLINDER)
		{
			//ȉ~`
			float a = rigid[k].vSize.x * rigid[k].vSize.x / 4.0;
			float b = rigid[k].vSize.y * rigid[k].vSize.y / 4.0;
			float f =  vPoint.x*vPoint.x / a + vPoint.y*vPoint.y / b -1.0;
			if(f <= 0.0)
			{
				if(rigid[k].flagFixed == true) return 1.0;//ŒQ
				else                           return 2.0;//V
			}
		}
	}
	return 0.0;//O
}

