//myMath4.h
//OtBbNXpwCu
#define M_PI 3.14159265358979323846
double DEG_TO_RAD = M_PI / 180.0;
double RAD_TO_DEG = 180.0 / M_PI;

//----------------------------------------------------------
//3xNgZ
class CVector{

public:
//oϐ
	double x, y, z;
	//RXgN^
	CVector();
	CVector(double x0, double y0, double z0);
	//Zq
	void operator+=(CVector a);//Z
	void operator-=(CVector a);//Z
	void operator*=(double s);//XJZ
	void operator/=(double s);//XJZ
	friend CVector operator*(CVector a, double s);//XJZ
	friend CVector operator*(double s, CVector a);//XJZ
	friend CVector operator/(CVector a, double s);//XJZ
	friend CVector operator+(CVector a, CVector b);//Z
	friend CVector operator-(CVector a, CVector b);//Z
	friend CVector operator>>(CVector a, CVector b);//ab֌PʃxNg
	//o֐
	double magnitude();  //傫
	double magnitudeXY();//傫(z𖳎)
	double magnitude2();  //傫2
	double magnitudeXY2();//傫2(z𖳎)
	void norm(void);//傫1̃xNgɕϊ
	void reverse(void);//]
	double vDist(CVector a, CVector b);//
	double vDistXY(CVector a, CVector b);//xyʓ̋
	double vDist2(CVector a, CVector b);//2拗
	CVector reverse2();//]xNgԂ
	CVector norm2();//KxNgԂ
	CVector normXY2();//KxNgԂ(z𖳎)
	CVector normYZ2();//KxNgԂ(x𖳎)
	CVector normXZ2();//KxNgԂ(y𖳎)
	double vDot(CVector a, CVector b);//
	CVector vCross(CVector a, CVector b);//O
	CVector rotate(CVector v, CVector elr);//IC[pɂ]
	CVector rotate(CVector v, double angle[3]);//pxzɂ]
	CVector rotateReverse(CVector v, CVector elr);//IC[pɂtŕ̉]
	void scale(CVector vSize);//ݸ
	void rotX(double angle); //x](deg)
	void rotY(double angle); //y]
	void rotZ(double angle); //z]
	void rotX_rad(double angle); //x](rad)
	void rotY_rad(double angle); //y]
	void rotZ_rad(double angle); //z]
	void rotX_rad(CVector vPos0, double angle); //x](rad)
	void rotY_rad(CVector vPos0, double angle); //y]
	void rotZ_rad(CVector vPos0, double angle); //z]
	double getAngle(CVector a, CVector b);//Q̃xNĝȂpx
	CVector getEulerX(CVector a, CVector b);//a炂֌xNg̃IC[p
	CVector getEulerZ(CVector a, CVector b);//a炂֌xNg̃IC[p
	CVector getEulerX(CVector d);//xNgd̃IC[p
	CVector getEulerZ(CVector d);//xNgd̃IC[p
};
//----------------------------------------------------------------------------
//RXgN^
CVector::CVector()
{
    x = y = z = 0.0;
}
//----------------------------------------------------------------------------
//RXgN^
CVector::CVector(double x0, double y0, double z0)
{
    x = x0;
    y = y0;
    z = z0;
}
//------------------------------------------------------------------------------
void CVector::operator+=(CVector a)
{
    x += a.x;
    y += a.y;
    z += a.z;
}
//------------------------------------------------------------------------------
void CVector::operator-=(CVector a)
{
    x -= a.x;
    y -= a.y;
    z -= a.z;
}
//------------------------------------------------------------------------------
void CVector::operator*=(double s)
{
    x *= s;
    y *= s;
    z *= s;
}
//------------------------------------------------------------------------------
void CVector::operator/=(double s)
{
    x /= s;
    y /= s;
    z /= s;
}
//------------------------------------------------------------------------------
CVector operator+(CVector a, CVector b)
{
    return CVector(a.x+b.x, a.y+b.y, a.z+b.z);
}
//------------------------------------------------------------------------------
CVector operator-(CVector a, CVector b)
{
    return CVector(a.x - b.x, a.y - b.y, a.z - b.z);
}
//------------------------------------------------------------------------------
//XJZ
CVector operator*(CVector a, double s)
{
    return CVector(a.x * s, a.y * s, a.z * s);
}
//------------------------------------------------------------------------------
//XJZ
CVector operator*(double s, CVector a)
{
    return CVector(a.x * s, a.y * s, a.z * s);
}
//------------------------------------------------------------------------------
//XJZ
CVector operator/(CVector a, double s)
{
    if(s == 0.0)
			printf("XJZ̕ꂪOłI \n");

    return CVector(a.x / s, a.y / s, a.z / s);
}

//------------------------------------------------------------------------------
//ab֌PʃxNg
CVector operator>>(CVector a, CVector b)
{
    CVector c = b - a;
    c.norm();
    return c ;
}

//-----------------------------------------------------------------------------
double CVector::magnitude()
{
    return( sqrt(x * x + y * y + z * z) );
}
//-----------------------------------------------------------------------------
double CVector::magnitudeXY()
{
    return( sqrt(x * x + y * y) );
}
//----------------------------------------------------------------------------
double CVector::magnitude2()
{
    return(x * x + y * y + z * z);
}
//-----------------------------------------------------------------------------
double CVector::magnitudeXY2()
{
    return(x * x + y * y);
}
//-----------------------------------------------------------------------------
void CVector::norm()
{
    double eps = 0.000001;
    double mag = sqrt(x * x + y * y + z * z) ;

	if(mag <= eps){ mag = 1.0;}
    x /= mag;
    y /= mag;
    z /= mag;
    if(fabs(x) < eps) x = 0.0;
    if(fabs(y) < eps) y = 0.0;
    if(fabs(z) < eps) z = 0.0;
}
//-----------------------------------------------------------------------------
CVector CVector::norm2()
{
    double eps = 0.000001;
    double xx, yy, zz;
    double mag = sqrt(x * x + y * y + z * z) ;
    if(mag < eps) mag = 1.0;
    xx = x / mag;
    yy = y / mag;
    zz = z / mag;
    if(fabs(x) < eps) xx = 0.0;
    if(fabs(y) < eps) yy = 0.0;
    if(fabs(z) < eps) zz = 0.0;
    return(CVector(xx, yy, zz));
}
//-----------------------------------------------------------------------------
CVector CVector::normXY2()
{
    double eps = 0.000001;
    double xx, yy;
    double mag = sqrt(x * x + y * y) ;
    if(mag < eps) mag = 1.0;
    xx = x / mag;
    yy = y / mag;
    if(fabs(x) < eps) xx = 0.0;
    if(fabs(y) < eps) yy = 0.0;
    return(CVector(xx, yy, 0.0));
}
//-----------------------------------------------------------------------------
CVector CVector::normYZ2()
{
    double eps = 0.000001;
    double yy, zz;
    double mag = sqrt(y * y + z * z) ;
    if(mag < eps) mag = 1.0;
    zz = z / mag;
    yy = y / mag;
    if(fabs(z) < eps) zz = 0.0;
    if(fabs(y) < eps) yy = 0.0;
    return(CVector(0.0, yy, zz));
}
//-----------------------------------------------------------------------------
CVector CVector::normXZ2()
{
    double eps = 0.000001;
    double xx, zz;
    double mag = sqrt(x * x + z * z) ;
    if(mag < eps) mag = 1.0;
    xx = x / mag;
    zz = z / mag;
    if(fabs(x) < eps) xx = 0.0;
    if(fabs(z) < eps) zz = 0.0;
    return(CVector(xx, 0.0, zz));
}

//-----------------------------------------------------------------------------
void CVector::reverse()
{
    x = -x;
    y = -y;
    z = -z;
}
//-----------------------------------------------------------------------------
CVector CVector::reverse2()
{
	CVector v = CVector();
	v.x = -x;
	v.y = -y;
	v.z = -z;
	return(v);
}
//------------------------------------------------------------------------------
//
double vDot(CVector a, CVector b)
{
    return( a.x*b.x + a.y*b.y + a.z*b.z );
}
//------------------------------------------------------------------------------
//O
CVector vCross(CVector a, CVector b)
{
    double x = a.y * b.z - a.z * b.y;
    double y = a.z * b.x - a.x * b.z;
    double z = a.x * b.y - a.y * b.x;
    return( CVector(x, y, z) );
}

//-----------------------------------------------------------------------------
void CVector::scale(CVector vSize)
{
	double xx, yy, zz;

	xx = x; yy = y; zz = z;
	x = xx * vSize.x;
	y = yy * vSize.y;
	z = zz * vSize.z;
}

//------------------------------------------------------------------------------------
void CVector::rotX(double angle)
{//angle:deg
	double xx, yy, zz;

	xx = x; yy = y; zz = z;
	x = xx;
	y = yy * cos(DEG_TO_RAD * angle) - zz * sin(DEG_TO_RAD * angle);
	z = yy * sin(DEG_TO_RAD * angle) + zz * cos(DEG_TO_RAD * angle);
}
//------------------------------------------------------------------------------------
void CVector::rotY(double angle)
{
	double xx, yy, zz;

	xx = x; yy = y; zz = z;
	x = xx * cos(DEG_TO_RAD * angle) + zz * sin(DEG_TO_RAD * angle);
	y = yy;
	z = - xx * sin(DEG_TO_RAD * angle) + zz * cos(DEG_TO_RAD * angle);
}
//------------------------------------------------------------------------------------
void CVector::rotZ(double angle)
{
	double xx, yy, zz;

	xx = x; yy = y; zz = z;
	x = xx * cos(DEG_TO_RAD * angle) - yy * sin(DEG_TO_RAD * angle);
	y = xx * sin(DEG_TO_RAD * angle) + yy * cos(DEG_TO_RAD * angle);
	z = zz;
}
//-----------------------------------------------------------------------------
CVector rotate(CVector v, CVector elr)
{
    v.rotX(elr.x);
    v.rotY(elr.y);
    v.rotZ(elr.z);
    return v;
}

CVector rotate(CVector v, double angle[3])
{
    v.rotX(angle[0]);
    v.rotY(angle[1]);
    v.rotZ(angle[2]);
    return v;
}
//------------------------------------------------------------------------------------
void CVector::rotX_rad(double angle)
{//angle:rad
	double xx, yy, zz;

	xx = x; yy = y; zz = z;
	x = xx;
	y = yy * cos(angle) - zz * sin(angle);
	z = yy * sin(angle) + zz * cos(angle);
}
//------------------------------------------------------------------------------------
void CVector::rotY_rad(double angle)
{
	double xx, yy, zz;

	xx = x; yy = y; zz = z;
	x = xx * cos(angle) + zz * sin(angle);
	y = yy;
	z = - xx * sin(angle) + zz * cos(angle);
}
//------------------------------------------------------------------------------------
void CVector::rotZ_rad(double angle)
{
	double xx, yy, zz;

	xx = x; yy = y; zz = z;
	x = xx * cos(angle) - yy * sin(angle);
	y = xx * sin(angle) + yy * cos(angle);
	z = zz;
}
//------------------------------------------------------------------------------------
void CVector::rotX_rad(CVector vPos0, double angle)
{//angle:rad
	//vPos0𒆐SƂ]
	double xx, yy, zz;

	xx = x; yy = y - vPos0.y; zz = z - vPos0.z;
	x = xx;
	y = yy * cos(angle) - zz * sin(angle) + vPos0.y;
	z = yy * sin(angle) + zz * cos(angle) + vPos0.z;
}
//------------------------------------------------------------------------------------
void CVector::rotY_rad(CVector vPos0, double angle)
{
	double xx, yy, zz;

	xx = x - vPos0.x; yy = y; zz = z - vPos0.z;
	x = xx * cos(angle) + zz * sin(angle) + vPos0.x;
	y = yy;
	z = - xx * sin(angle) + zz * cos(angle) + vPos0.z;
}
//------------------------------------------------------------------------------------
void CVector::rotZ_rad(CVector vPos0, double angle)
{
	double xx, yy, zz;

	xx = x - vPos0.x; yy = y - vPos0.y; zz = z;
	x = xx * cos(angle) - yy * sin(angle) + vPos0.x;
	y = xx * sin(angle) + yy * cos(angle) + vPos0.y;
	z = zz;
}

CVector rotateReverse(CVector v, CVector elr)
{
    //tŕ̉]
    v.rotZ(-elr.z);
    v.rotY(-elr.y);
    v.rotX(-elr.x);
    return v;
}
//------------------------------------------------------------------------------
//xNgԋ
double vDist(CVector a, CVector b)
{
    CVector c = b - a;
    return( c.magnitude() );
}
//------------------------------------------------------------------------------
//xNgԋ(xyʁj
double vDistXY(CVector a, CVector b)
{
    CVector c = b - a;
    return( c.magnitudeXY() );
}
//------------------------------------------------------------------------------
//xNgԓ拗
double vDist2(CVector a, CVector b)
{
    CVector c = b - a;
    return ( c.x * c.x + c.y * c.y + c.z * c.z);
}

//-----------------------------------------------------------------------------
double getAngle(CVector a, CVector b)
{
    double ang = (a.x*b.x+a.y*b.y+a.z*b.z)/(a.magnitude()*b.magnitude());
    if(ang >= 1.0) ang = 0.0;
    else if (ang <= -1.0) ang = M_PI;
    else ang = acos(ang);
    return ang;//radPʂŕԂ
}
//-----------------------------------------------------------------------------
CVector getEulerX(CVector a, CVector b)
{//{pŒSł_IuWFNg̃IC[p(deg)
    double cx, cy, cz, len;
    CVector e;
    cx = b.x - a.x;
    cy = b.y - a.y;
    cz = b.z - a.z;
    len = vDist(a, b);
    e.x = 0.0;
    if(cz >= len) e.y = -90.0;
    else if(cz <= -len) e.y = 90.0;
    else e.y = - asin(cz / len) * RAD_TO_DEG;
    if(fabs(cx) <= 0.0001 && fabs(cy) <= 0.0001) e.z = 0.0;
		else e.z = atan2(cy, cx) * RAD_TO_DEG;
    return e;
}
//-----------------------------------------------------------------------------
CVector getEulerX(CVector d)
{//{pŒSł_IuWFNg̃IC[p(deg)
    double cx, cy, cz, len;
    CVector e;
    cx = d.x;
    cy = d.y;
    cz = d.z;
    len = d.magnitude();
    e.x = 0.0;
    if(cz >= len) e.y = -90.0;
    else if(cz <= -len) e.y = 90.0;
    else e.y = - asin(cz / len) * RAD_TO_DEG;
    if(fabs(cx) <= 0.0001 && fabs(cy) <= 0.0001) e.z = 0.0;
		else e.z = atan2(cy, cx) * RAD_TO_DEG;
    return e;
}
//------------------------------------------------------------------------------
CVector getEulerZ(CVector a, CVector b)
{//{pŒSzł_IuWFNg̃IC[p(deg)
		//2011.3.14
    double cx, cy, cz, len;
    CVector e;
    cx = b.x - a.x;
    cy = b.y - a.y;
    cz = b.z - a.z;
    len = vDist(a, b);
    e.z = 0.0;
    if(cy >= len) e.x = -90.0;
    else if(cy <= -len) e.x = 90.0;
    else e.x = -asin(cy / len) * RAD_TO_DEG;
    if(fabs(cx) <= 0.0001 && fabs(cz) <= 0.0001) e.y = 0.0;
    else e.y = atan2(cx, cz) * RAD_TO_DEG;
    return e;
}
//------------------------------------------------------------------------------
CVector getEulerZ(CVector d)
{//{pŒSzł_IuWFNg̃IC[p(deg)
    double cx, cy, cz, len;
    CVector e;
    cx = d.x;
    cy = d.y;
    cz = d.z;
    len = d.magnitude();
    e.z = 0.0;
    if(cy >= len) e.x = -90.0;
    else if(cy <= -len) e.x = 90.0;
    else e.x = -asin(cy / len) * RAD_TO_DEG;
    if(fabs(cx) <= 0.0001 && fabs(cz) <= 0.0001) e.y = 0.0;
    else e.y = atan2(cx, cz) * RAD_TO_DEG;
    return e;
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//3*3̃}gNX
//------------------------------------------------------------------------------
class CMatrix{

public:
    //oϐ
    double e11, e12, e13, e21, e22, e23, e31, e32, e33;
    //RXgN^
    CMatrix();
    CMatrix(double a11, double a12, double a13,
            double a21, double a22, double a23,
            double a31, double a32, double a33);
    //Zq
    friend CVector operator*(CMatrix m, CVector v);
    friend CVector operator*(CVector v, CMatrix m);
    //o֐
    double det();
    CMatrix inverse();
};
//----------------------------------------------------------------------------
//RXgN^
CMatrix::CMatrix()
{
    e11 = e12 = e13 = 0.0;
    e21 = e22 = e23 = 0.0;
    e31 = e32 = e33 = 0.0;
}
//-----------------------------------------------------------------------------
//RXgN^
CMatrix::CMatrix(double a11, double a12, double a13,
                 double a21, double a22, double a23,
                 double a31, double a32, double a33)
{
    e11 = a11; e12 = a12; e13 = a13;
    e21 = a21; e22 = a22; e23 = a23;
    e31 = a31; e32 = a32; e33 = a33;
}
//----------------------------------------------------------------------------
//s
double CMatrix::det()
{
    return( e11*e22*e33 + e12*e23*e31 + e13*e32*e21
          - e11*e32*e23 - e12*e21*e33 - e31*e22*e13 );
}
//----------------------------------------------------------------------------
CMatrix CMatrix::inverse()
{
    double d = e11*e22*e33 + e12*e23*e31 + e13*e32*e21
             - e11*e32*e23 - e12*e21*e33 - e31*e22*e13 ;
    if( d == 0.0 ) {
			 printf("ts߂邱Ƃł܂I \n");
       d = 1.0;
    }
    return CMatrix(
        (e22*e33-e23*e32)/d, -(e12*e33-e13*e32)/d,  (e12*e23-e13*e22)/d,
       -(e21*e33-e23*e31)/d,  (e11*e33-e13*e31)/d, -(e11*e23-e13*e21)/d,
        (e21*e32-e22*e31)/d, -(e11*e32-e12*e31)/d,  (e11*e22-e12*e21)/d );
}
//----------------------------------------------------------------------------
//xNgZ
CVector operator*(CMatrix m, CVector v)
{
    return CVector(
        m.e11*v.x + m.e12*v.y + m.e13*v.z,    //x
        m.e21*v.x + m.e22*v.y + m.e23*v.z,    //y
        m.e31*v.x + m.e32*v.y + m.e33*v.z );  //z
}
//----------------------------------------------------------------------------
//xNgZ
CVector operator*(CVector v, CMatrix m)
{
    return CVector(
        v.x*m.e11 + v.y*m.e21 + v.z*m.e31,
        v.x*m.e12 + v.y*m.e22 + v.z*m.e32,
        v.x*m.e13 + v.y*m.e23 + v.z*m.e33 );
}

//----------------------------------------------------------------------------
//lFquaternion
// ` q = s + xi + yj + zk;
//----------------------------------------------------------------------------
class CQuaternion{

public:
		//oϐ
		double s;//XJl
		CVector v;//xNg
		//RXgN^
		CQuaternion();
		CQuaternion(double a0, double a1, double a2, double a3);
		CQuaternion(double a0, CVector v);

		//Zq
		CQuaternion operator~();
		void operator+=(CQuaternion q);
		void operator-=(CQuaternion q);
		void operator*=(double a);
		void operator/=(double a);
		friend CQuaternion operator+(CQuaternion p, CQuaternion q);
		friend CQuaternion operator-(CQuaternion p, CQuaternion q);
		friend CQuaternion operator*(CQuaternion p, CQuaternion q);
		friend CQuaternion operator*(CQuaternion p, double s);
		friend CQuaternion operator*(double s, CQuaternion p);
		friend CQuaternion operator*(CVector v, CQuaternion q);
		friend CQuaternion operator*(CQuaternion q, CVector v);
		//o֐
		double magnitude(void);
		void norm(void);//傫1quaternionɕϊ
		CVector getVector();
		double getScalar();
		CVector qvRotate(CQuaternion q, CVector v);
		CQuaternion getQFromEulerXYZ(CVector elr);
		CQuaternion getQFromEulerZYX(CVector elr);
		CQuaternion getQFromAxis(double angle, CVector axis);
};
//-----------------------------------------------------------------------------
//RXgN^
CQuaternion::CQuaternion()
{
    s = 1.0;
    v.x = v.y = v.z = 0.0;
}
//-----------------------------------------------------------------------------
//RXgN^
CQuaternion::CQuaternion(double a0, double a1, double a2, double a3)
{
    s = a0;
    v.x = a1;
    v.y = a2;
    v.z = a3;
}
//-----------------------------------------------------------------------------
//RXgN^
CQuaternion::CQuaternion(double a0, CVector u)
{
    s = a0;
		v = u;
}
//-----------------------------------------------------------------------------
//l
CQuaternion CQuaternion::operator~()
{
    return CQuaternion( s, -v.x, -v.y, -v.z);
}
//-----------------------------------------------------------------------------
void CQuaternion::operator+=(CQuaternion q)
{
    s += q.s;
    v.x += q.v.x;
    v.y += q.v.y;
    v.z += q.v.z;
}
//-----------------------------------------------------------------------------
void CQuaternion::operator-=(CQuaternion q)
{
    s -= q.s;
    v.x -= q.v.x;
    v.y -= q.v.y;
    v.z -= q.v.z;
}
//-----------------------------------------------------------------------------
void CQuaternion::operator*=(double a)
{
    s *= a;
    v.x *= a;
    v.y *= a;
    v.z *= a;
}
//-----------------------------------------------------------------------------
void CQuaternion::operator/=(double a)
{
    s /= a;
    v.x /= a;
    v.y /= a;
    v.z /= a;
}

//------------------------------------------------------------------------------
//lǂ̘a
CQuaternion operator+(CQuaternion p, CQuaternion q)
{
    return CQuaternion( p.s + q.s,
           p.v.x + q.v.x, p.v.y + q.v.y, p.v.z + q.v.z);
}
//------------------------------------------------------------------------------
//lǂ̍
CQuaternion operator-(CQuaternion p, CQuaternion q)
{
    return CQuaternion( p.s - q.s,
           p.v.x - q.v.x, p.v.y - q.v.y, p.v.z - q.v.z);
}
//------------------------------------------------------------------------------
//lǂ̏Z
CQuaternion operator*(CQuaternion p, CQuaternion q)
{
    CQuaternion qq;
     qq.s = p.s * q.s - vDot(p.v , q.v) ; //Qڂ̓xNg
     qq.v = p.s * q.v + q.s * p.v + vCross(p.v , q.v); //Rڂ̓xNgO
    return qq;
}
//-----------------------------------------------------------------------------
//XJZ
CQuaternion operator*(CQuaternion p, double a)
{
    return CQuaternion(p.s * a, p.v.x * a, p.v.y * a, p.v.z * a);
}
//-----------------------------------------------------------------------------
//XJZ
CQuaternion operator*(double a, CQuaternion p)
{
    return CQuaternion(p.s * a, p.v.x * a, p.v.y * a, p.v.z * a);
}
//------------------------------------------------------------------------------
//xNgƎl̏Z
CQuaternion operator*(CVector v, CQuaternion q)
{
    CQuaternion p, pp;
    p.s = 0.0; p.v = v; //XJ0̃NI[^jI
    pp = p * q;
    return pp; 
}
//------------------------------------------------------------------------------
//xNgƎl̏Z
CQuaternion operator*(CQuaternion p, CVector v)
{
    CQuaternion q, pp;
    q.s = 0.0; q.v = v;
    pp = p * q;
    return pp;
}

//-----------------------------------------------------------------------------
//傫Ԃ
double CQuaternion::magnitude()
{
    return sqrt( s * s + v.x * v.x + v.y * v.y + v.z * v.z);
}
//-----------------------------------------------------------------------------
//K
void CQuaternion::norm()
{
    double eps = 0.000001;
    double mag = sqrt(s * s + v.x * v.x + v.y * v.y + v.z * v.z) ;
		if(mag <= eps) mag = 1.0;
		s /= mag;
    v.x /= mag;
    v.y /= mag;
    v.z /= mag;
		if(fabs(s) < eps) s = 0.0;
    if(fabs(v.x) < eps) v.x = 0.0;
    if(fabs(v.y) < eps) v.y = 0.0;
    if(fabs(v.z) < eps) v.z = 0.0;
}

//-----------------------------------------------------------------------------
//xNgԂ
CVector CQuaternion::getVector()
{
    return CVector(v.x, v.y, v.z);
}
//-----------------------------------------------------------------------------
//XJԂ
double CQuaternion::getScalar()
{
    return s;
}
//-----------------------------------------------------------------------------
//xNgvSqŉ]
CVector qvRotate(CQuaternion q, CVector v)
{
    CQuaternion p = q * v * (~q);
    return CVector(p.v.x, p.v.y, p.v.z);
}
//------------------------------------------------------------------------------
//Cӂ̉]S擾(axis͊W, angle[deg]j
CQuaternion getQFromAxis(double angle, CVector axis)
{
	CQuaternion q0;
	if(fabs(angle) > 90.0) {//fabs(angle > 90.0)ɑΉ悤ɕύXi2011.3.10)
		q0 = getQFromAxis(angle/2.0, axis);
		angle /= 2.0;
	}

  axis.norm();
  double a2 = (double)(angle * DEG_TO_RAD / 2.0);//radPʂŃ/2
	if(a2 > 1.0) a2 = 1.0;
	if(a2 < -1.0) a2 = -1.0;
  return CQuaternion( cos(a2) , axis * sin(a2)) * q0;
}
//------------------------------------------------------------------------
CQuaternion getQFromEulerXYZ(CVector elr)
{//x,y,z̏Ԃŉ]
	CQuaternion q;
	q = getQFromAxis(elr.z, CVector(0.0, 0.0, 1.0)) 
		* getQFromAxis(elr.y, CVector(0.0, 1.0, 0.0))
		* getQFromAxis(elr.x, CVector(1.0, 0.0, 0.0));
	return q;
}

//------------------------------------------------------------------------
CQuaternion getQFromEulerZYX(CVector elr)
{//z,y,x̏Ԃŉ]
	CQuaternion q;
	q = getQFromAxis(elr.x, CVector(1.0, 0.0, 0.0)) 
		* getQFromAxis(elr.y, CVector(0.0, 1.0, 0.0))
		* getQFromAxis(elr.z, CVector(0.0, 0.0, 1.0));
	return q;
}
//------------------------------------------------------
//
double getRandom(double fMin, double fMax)
{//l
  return fMin + (fMax - fMin) * (double)rand() / (double)RAND_MAX;
}

//XYʂɂˏ̈l
CVector getRandomVectorXY()
{
	CVector vPos;
	double r = getRandom(0.0, 1.0);
	double theta = getRandom(-M_PI, M_PI);
	vPos.x = (double)cos(theta) * r;
	vPos.y = (double)sin(theta) * r;
	return vPos;
}
//XYʂɂˏ̈l(xCẙmj
CVector getRandomVectorXY2()
{
	CVector vPos;
	vPos.z = 0.0;
	double theta = getRandom(-M_PI, M_PI);
	vPos.x = (double)cos(theta) * getRandom(-1.0, 1.0);
	vPos.y = (double)sin(theta) * getRandom(-1.0, 1.0);
	return vPos;
}

//K
double getNormalRandom(double mean, double sigma)
{
	double ran = 0.0;
	for(int i = 0; i < 12; i++) ran += (double)rand() / (double)RAND_MAX;
	ran -= 6.0;
	ran *= sigma;
	return mean + ran;
}

//3DԂɂ鋅̈l
//Ԗxقڈ
CVector getRandomXYZ()
{
	CVector vPos;
	vPos.z = getRandom(-1.0, 1.0);
	double r = (double)sqrt(1.0 - vPos.z * vPos.z);
	double theta = getRandom(-M_PI, M_PI);
	vPos.x = (double)cos(theta) * r;
	vPos.y = (double)sin(theta) * r;
	return vPos;
}
//3DԂɂˏ̗
//Sقǖx
CVector getRandomVector()
{
	CVector vPos;
	CVector vDir = CVector(getRandom(-1.0, 1.0), getRandom(-1.0, 1.0), getRandom(-1.0, 1.0));
	double r = getRandom(0.0, 1.0);
	double len = vDir.magnitude();
	vPos = r * vDir / len;
	return vPos;
}

//Oɕz闐(Sقǖx͍)
CVector getRandomRingVectorXY(double minR, double maxR)
{
	CVector vPos;
	double r = getRandom(minR, maxR);
	double theta = getRandom(-M_PI, M_PI);
	vPos.x = (double)cos(theta) * r;
	vPos.y = (double)sin(theta) * r;
	return vPos;
}
