//rigid3DSM.h(ol_ɗp鍄)
#include "../../parametersSM.h"
//#include "springTree.h"

#define RIGID_NUM_MAX 2
//#define NON_COLLISION -999;
//int numRigid0 = 2;//̐
//int numRigid = 2;//Xg{܂߂

//-------------------------------------------------------------------------
class CRigid{
public:
	//ޕϐ
	Kind kind;    //CRigid̎
	Color color;  //F
	CVector vSize;//TCY
	CVector vPos; //ʒu
	CVector vPos0;//ݒl
	CVector vEuler;//IC[p(p̏ݒ,deg)
	CVector vAxis; //]
	float angle;   //]px(rad)

	//^V~[Vp
	float mass;        //(Kg)

	CVector vForce;    //O(Newton)
	CVector vForce0, vForce1; //O͏l
	CVector vTorque;   //͂̃[gigN,Newton/mj
	CVector vAccel;    //x(m/s^2)
	CVector vVelocity; //x(m/s)
	CVector vOmega;    //px(rad/s)
	CVector vAlpha;    //px(rad/s^2)
	CVector vGravityToPoint;//dSՓ˓_܂ł̃xNg
//	CMatrix mInertia; //[g̃e\
//	CMatrix mInertiaInverse;
	CQuaternion q;

//	int select;
	bool flagFixed;

	//ފ֐
	CRigid();  //RXgN^
	~CRigid(); //fXgN^
	void draw(bool flagShadow);
};
CRigid rigid[RIGID_NUM_MAX];

//--------------------------------------------------
CRigid::CRigid()
{
	kind = SPHERE;
	color = WHITE;
	vSize = CVector(0.1, 0.1, 0.1);//Փ˔莞̎_̑傫
	vPos = CVector(0.0, 0.0, 3.0);
	vForce = vForce0 = CVector();
	vVelocity = CVector();
//	vOmega = CVector(0.0, 0.0, 0.0);//px(rad)
//	vEuler = CVector();
//	q = CQuaternion();
	flagFixed = false;
	mass = 1.0;
}

//--------------------------------------------------
CRigid::~CRigid()
{
}

//---------------------------------------------------------
void CRigid::draw(bool flagShadow)
{
	//ẽ}eA
	static float shadowDiffuse[] =  {0.2,0.2,0.2,0.3};//e̊gU
	static float shadowSpecular[] = {0.0,0.0,0.0,1.0};//e̋ʌ

	glPushMatrix();
    //݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ

	//]
	glRotatef(vEuler.z, 0.0, 0.0, 1.0);
	glRotatef(vEuler.y, 0.0, 1.0, 0.0);
	glRotatef(vEuler.x, 1.0, 0.0, 0.0);
/*
	//]
	if(q.s > 1.0) q.s = 1.0;
	if(q.s < -1.0) q.s = -1.0;
	angle = 2.0 * acos(q.s);//[rad]
	vAxis = q.v.norm2();
	glRotatef(angle * RAD_TO_DEG, vAxis.x, vAxis.y, vAxis.z);//]pdegɕϊ
*/
	//̂̃}eA
	static float white0[] = { 0.9, 0.9, 0.9, 1.0};//I
	static float specular[] = { 0.8, 0.8, 0.8, 1.0};
	static float specularS[]= { 0.6, 0.6, 0.6, 1.0};

	if(!flagShadow)
	{
		if(color == RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, red);
		if(color == GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, green);
		if(color == BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, blue);
		if(color == YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, yellow);
		if(color == CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, cyan);
		if(color == MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, magenta);
		if(color == WHITE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white);
		if(color == GRAY) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, gray);
		if(color == DARK_RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_red);
		if(color == DARK_GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_green);
		if(color == DARK_BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_blue);
		if(color == DARK_YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_yellow);
		if(color == DARK_CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_cyan);
		if(color == DARK_MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_magenta);

//		if(select) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white0);
		
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 100.0);
	}
	else
	{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
	}

	//XP[O
	glScalef(vSize.x, vSize.y, vSize.z);
/*
	//޼ުĂ̕`
	if(select==1)
	{//Îtexture`
		if(kind == SPHERE) glCallList(sphereTex);
		else if(kind == CUBE) glCallList(cubeTex);
		else if(kind == CYLINDER) glCallList(cylinderTex);
	}
	else*/
	{//ʏ
		if(kind == SPHERE) glCallList(sphere);
		else if(kind == CUBE) glCallList(cube);
		else if(kind == CYLINDER) glCallList(cylinder);
	}
	glPopMatrix();
}
